<?php

declare(strict_types=1);

namespace NOUT\Soap;

/**
 * Class which returns the class map definition
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get(): array
    {
        return [
            'DataType' => '\\NOUT\\Soap\\StructType\\DataType',
            'EmptyType' => '\\NOUT\\Soap\\StructType\\EmptyType',
            'SortType' => '\\NOUT\\Soap\\StructType\\SortType',
            'SpecialParamListType' => '\\NOUT\\Soap\\StructType\\SpecialParamListType',
            'EncryptionType' => '\\NOUT\\Soap\\StructType\\EncryptionType',
            'UsernameTokenType' => '\\NOUT\\Soap\\StructType\\UsernameTokenType',
            'XmlType' => '\\NOUT\\Soap\\StructType\\XmlType',
            'CallingInfoType' => '\\NOUT\\Soap\\StructType\\CallingInfoType',
            'ColListType' => '\\NOUT\\Soap\\StructType\\ColListType',
            'ColumnsToRefresh' => '\\NOUT\\Soap\\StructType\\ColumnsToRefresh',
            'SelectedItemsType' => '\\NOUT\\Soap\\StructType\\SelectedItemsType',
            'VirtualParamType' => '\\NOUT\\Soap\\StructType\\VirtualParamType',
            'VirtualParamListType' => '\\NOUT\\Soap\\StructType\\VirtualParamListType',
            'FilterType' => '\\NOUT\\Soap\\StructType\\FilterType',
            'ConnectedExtranet' => '\\NOUT\\Soap\\StructType\\ConnectedExtranet',
            'PwdInfo' => '\\NOUT\\Soap\\StructType\\PwdInfo',
            'FormElement' => '\\NOUT\\Soap\\StructType\\FormElement',
            'ConnectedUser' => '\\NOUT\\Soap\\StructType\\ConnectedUser',
            'Count' => '\\NOUT\\Soap\\StructType\\Count',
            'IDIHMToClose' => '\\NOUT\\Soap\\StructType\\IDIHMToClose',
            'OptionDialogue' => '\\NOUT\\Soap\\StructType\\OptionDialogue',
            'Action' => '\\NOUT\\Soap\\StructType\\Action',
            'Element' => '\\NOUT\\Soap\\StructType\\Element',
            'Filter' => '\\NOUT\\Soap\\StructType\\Filter',
            'Form' => '\\NOUT\\Soap\\StructType\\Form',
            'GlobalEvents' => '\\NOUT\\Soap\\StructType\\GlobalEvents',
            'PlanningFilter' => '\\NOUT\\Soap\\StructType\\PlanningFilter',
            'RequestHeader' => '\\NOUT\\Soap\\StructType\\RequestHeader',
            'ColumnListType' => '\\NOUT\\Soap\\StructType\\ColumnListType',
            'ValidateError' => '\\NOUT\\Soap\\StructType\\ValidateError',
            'FolderCount' => '\\NOUT\\Soap\\StructType\\FolderCount',
            'RecipientCheck' => '\\NOUT\\Soap\\StructType\\RecipientCheck',
            'ExtranetUserType' => '\\NOUT\\Soap\\StructType\\ExtranetUserType',
            'GetTokenSession' => '\\NOUT\\Soap\\StructType\\GetTokenSession',
            'GetTokenSessionResponse' => '\\NOUT\\Soap\\StructType\\GetTokenSessionResponse',
            'InitRecordFromAddress' => '\\NOUT\\Soap\\StructType\\InitRecordFromAddress',
            'InitRecordFromAddressResponse' => '\\NOUT\\Soap\\StructType\\InitRecordFromAddressResponse',
            'InitRecordFromMessage' => '\\NOUT\\Soap\\StructType\\InitRecordFromMessage',
            'InitRecordFromMessageResponse' => '\\NOUT\\Soap\\StructType\\InitRecordFromMessageResponse',
            'ResetPasswordFailed' => '\\NOUT\\Soap\\StructType\\ResetPasswordFailed',
            'ResetPasswordFailedResponse' => '\\NOUT\\Soap\\StructType\\ResetPasswordFailedResponse',
            'ActionFromMessage' => '\\NOUT\\Soap\\StructType\\ActionFromMessage',
            'ActionFromMessageResponse' => '\\NOUT\\Soap\\StructType\\ActionFromMessageResponse',
            'AuditAction' => '\\NOUT\\Soap\\StructType\\AuditAction',
            'AuditActionResponse' => '\\NOUT\\Soap\\StructType\\AuditActionResponse',
            'AutoComplete' => '\\NOUT\\Soap\\StructType\\AutoComplete',
            'AutoCompleteResponse' => '\\NOUT\\Soap\\StructType\\AutoCompleteResponse',
            'ColumnSelection' => '\\NOUT\\Soap\\StructType\\ColumnSelection',
            'ButtonAction' => '\\NOUT\\Soap\\StructType\\ButtonAction',
            'ButtonActionResponse' => '\\NOUT\\Soap\\StructType\\ButtonActionResponse',
            'Cancel' => '\\NOUT\\Soap\\StructType\\Cancel',
            'CancelResponse' => '\\NOUT\\Soap\\StructType\\CancelResponse',
            'CheckCtrl' => '\\NOUT\\Soap\\StructType\\CheckCtrl',
            'CheckCtrlResponse' => '\\NOUT\\Soap\\StructType\\CheckCtrlResponse',
            'ConfirmResponse' => '\\NOUT\\Soap\\StructType\\ConfirmResponse',
            'ConfirmResponseResponse' => '\\NOUT\\Soap\\StructType\\ConfirmResponseResponse',
            'Copy' => '\\NOUT\\Soap\\StructType\\Copy',
            'CopyResponse' => '\\NOUT\\Soap\\StructType\\CopyResponse',
            'Create' => '\\NOUT\\Soap\\StructType\\Create',
            'CreateResponse' => '\\NOUT\\Soap\\StructType\\CreateResponse',
            'CreateFrom' => '\\NOUT\\Soap\\StructType\\CreateFrom',
            'CreateFromResponse' => '\\NOUT\\Soap\\StructType\\CreateFromResponse',
            'Delete' => '\\NOUT\\Soap\\StructType\\Delete',
            'DeleteResponse' => '\\NOUT\\Soap\\StructType\\DeleteResponse',
            'Display' => '\\NOUT\\Soap\\StructType\\Display',
            'DisplayResponse' => '\\NOUT\\Soap\\StructType\\DisplayResponse',
            'DrillThrough' => '\\NOUT\\Soap\\StructType\\DrillThrough',
            'DrillThroughResponse' => '\\NOUT\\Soap\\StructType\\DrillThroughResponse',
            'EnterReorderListModeResponse' => '\\NOUT\\Soap\\StructType\\EnterReorderListModeResponse',
            'Execute' => '\\NOUT\\Soap\\StructType\\Execute',
            'ExecuteResponse' => '\\NOUT\\Soap\\StructType\\ExecuteResponse',
            'ExecuteWithoutIHM' => '\\NOUT\\Soap\\StructType\\ExecuteWithoutIHM',
            'ExecuteWithoutIHMResponse' => '\\NOUT\\Soap\\StructType\\ExecuteWithoutIHMResponse',
            'Export' => '\\NOUT\\Soap\\StructType\\Export',
            'ExportResponse' => '\\NOUT\\Soap\\StructType\\ExportResponse',
            'CalculationListType' => '\\NOUT\\Soap\\StructType\\CalculationListType',
            'GetCalculation' => '\\NOUT\\Soap\\StructType\\GetCalculation',
            'GetCalculationResponse' => '\\NOUT\\Soap\\StructType\\GetCalculationResponse',
            'GetChart' => '\\NOUT\\Soap\\StructType\\GetChart',
            'GetChartResponse' => '\\NOUT\\Soap\\StructType\\GetChartResponse',
            'GetColInRecord' => '\\NOUT\\Soap\\StructType\\GetColInRecord',
            'GetColInRecordResponse' => '\\NOUT\\Soap\\StructType\\GetColInRecordResponse',
            'GetEndListCalculationResponse' => '\\NOUT\\Soap\\StructType\\GetEndListCalculationResponse',
            'GetEndAutomatism' => '\\NOUT\\Soap\\StructType\\GetEndAutomatism',
            'GetEndAutomatismResponse' => '\\NOUT\\Soap\\StructType\\GetEndAutomatismResponse',
            'LanguageCodeList' => '\\NOUT\\Soap\\StructType\\LanguageCodeList',
            'GetLanguagesResponse' => '\\NOUT\\Soap\\StructType\\GetLanguagesResponse',
            'GetPlanningInfo' => '\\NOUT\\Soap\\StructType\\GetPlanningInfo',
            'GetPlanningInfoResponse' => '\\NOUT\\Soap\\StructType\\GetPlanningInfoResponse',
            'GetStartAutomatism' => '\\NOUT\\Soap\\StructType\\GetStartAutomatism',
            'GetStartAutomatismResponse' => '\\NOUT\\Soap\\StructType\\GetStartAutomatismResponse',
            'GetSubListContent' => '\\NOUT\\Soap\\StructType\\GetSubListContent',
            'GetSubListContentResponse' => '\\NOUT\\Soap\\StructType\\GetSubListContentResponse',
            'GetTableChild' => '\\NOUT\\Soap\\StructType\\GetTableChild',
            'GetTableChildResponse' => '\\NOUT\\Soap\\StructType\\GetTableChildResponse',
            'GetTemporalAutomatismResponse' => '\\NOUT\\Soap\\StructType\\GetTemporalAutomatismResponse',
            'HasChangedResponse' => '\\NOUT\\Soap\\StructType\\HasChangedResponse',
            'Import' => '\\NOUT\\Soap\\StructType\\Import',
            'ImportResponse' => '\\NOUT\\Soap\\StructType\\ImportResponse',
            'List' => '\\NOUT\\Soap\\StructType\\_List',
            'ListResponse' => '\\NOUT\\Soap\\StructType\\ListResponse',
            'Merge' => '\\NOUT\\Soap\\StructType\\Merge',
            'MergeResponse' => '\\NOUT\\Soap\\StructType\\MergeResponse',
            'Modify' => '\\NOUT\\Soap\\StructType\\Modify',
            'ModifyResponse' => '\\NOUT\\Soap\\StructType\\ModifyResponse',
            'Paste' => '\\NOUT\\Soap\\StructType\\Paste',
            'PasteResponse' => '\\NOUT\\Soap\\StructType\\PasteResponse',
            'Print' => '\\NOUT\\Soap\\StructType\\_Print',
            'PrintResponse' => '\\NOUT\\Soap\\StructType\\PrintResponse',
            'ReorderList' => '\\NOUT\\Soap\\StructType\\ReorderList',
            'ReorderListResponse' => '\\NOUT\\Soap\\StructType\\ReorderListResponse',
            'ReorderSubList' => '\\NOUT\\Soap\\StructType\\ReorderSubList',
            'ReorderSubListResponse' => '\\NOUT\\Soap\\StructType\\ReorderSubListResponse',
            'Request' => '\\NOUT\\Soap\\StructType\\Request',
            'RequestResponse' => '\\NOUT\\Soap\\StructType\\RequestResponse',
            'RequestParam' => '\\NOUT\\Soap\\StructType\\RequestParam',
            'RequestParamResponse' => '\\NOUT\\Soap\\StructType\\RequestParamResponse',
            'Search' => '\\NOUT\\Soap\\StructType\\Search',
            'SearchResponse' => '\\NOUT\\Soap\\StructType\\SearchResponse',
            'SelectChoice' => '\\NOUT\\Soap\\StructType\\SelectChoice',
            'SelectChoiceResponse' => '\\NOUT\\Soap\\StructType\\SelectChoiceResponse',
            'SelectForm' => '\\NOUT\\Soap\\StructType\\SelectForm',
            'SelectFormResponse' => '\\NOUT\\Soap\\StructType\\SelectFormResponse',
            'SelectItems' => '\\NOUT\\Soap\\StructType\\SelectItems',
            'SelectItemsResponse' => '\\NOUT\\Soap\\StructType\\SelectItemsResponse',
            'SelectPrintTemplate' => '\\NOUT\\Soap\\StructType\\SelectPrintTemplate',
            'SelectPrintTemplateResponse' => '\\NOUT\\Soap\\StructType\\SelectPrintTemplateResponse',
            'SetOrderList' => '\\NOUT\\Soap\\StructType\\SetOrderList',
            'SetOrderListResponse' => '\\NOUT\\Soap\\StructType\\SetOrderListResponse',
            'SetOrderSubList' => '\\NOUT\\Soap\\StructType\\SetOrderSubList',
            'SetOrderSubListResponse' => '\\NOUT\\Soap\\StructType\\SetOrderSubListResponse',
            'TransformInto' => '\\NOUT\\Soap\\StructType\\TransformInto',
            'TransformIntoResponse' => '\\NOUT\\Soap\\StructType\\TransformIntoResponse',
            'Update' => '\\NOUT\\Soap\\StructType\\Update',
            'UpdateResponse' => '\\NOUT\\Soap\\StructType\\UpdateResponse',
            'UpdateFilter' => '\\NOUT\\Soap\\StructType\\UpdateFilter',
            'UpdateFilterResponse' => '\\NOUT\\Soap\\StructType\\UpdateFilterResponse',
            'ValidateResponse' => '\\NOUT\\Soap\\StructType\\ValidateResponse',
            'AddPJ' => '\\NOUT\\Soap\\StructType\\AddPJ',
            'AddPJResponse' => '\\NOUT\\Soap\\StructType\\AddPJResponse',
            'CancelFolder' => '\\NOUT\\Soap\\StructType\\CancelFolder',
            'CancelMessage' => '\\NOUT\\Soap\\StructType\\CancelMessage',
            'CheckCreateElement' => '\\NOUT\\Soap\\StructType\\CheckCreateElement',
            'CheckCreateElementResponse' => '\\NOUT\\Soap\\StructType\\CheckCreateElementResponse',
            'CheckRecipient' => '\\NOUT\\Soap\\StructType\\CheckRecipient',
            'CheckRecipientResponse' => '\\NOUT\\Soap\\StructType\\CheckRecipientResponse',
            'CloseFolderList' => '\\NOUT\\Soap\\StructType\\CloseFolderList',
            'CloseMessageList' => '\\NOUT\\Soap\\StructType\\CloseMessageList',
            'CreateFolderResponse' => '\\NOUT\\Soap\\StructType\\CreateFolderResponse',
            'CreateMessage' => '\\NOUT\\Soap\\StructType\\CreateMessage',
            'CreateMessageResponse' => '\\NOUT\\Soap\\StructType\\CreateMessageResponse',
            'DeleteFolder' => '\\NOUT\\Soap\\StructType\\DeleteFolder',
            'DeleteMessage' => '\\NOUT\\Soap\\StructType\\DeleteMessage',
            'DeletePJ' => '\\NOUT\\Soap\\StructType\\DeletePJ',
            'DeletePJResponse' => '\\NOUT\\Soap\\StructType\\DeletePJResponse',
            'DisplayRedoMessage' => '\\NOUT\\Soap\\StructType\\DisplayRedoMessage',
            'DisplayRedoMessageResponse' => '\\NOUT\\Soap\\StructType\\DisplayRedoMessageResponse',
            'DisplayUndoMessage' => '\\NOUT\\Soap\\StructType\\DisplayUndoMessage',
            'DisplayUndoMessageResponse' => '\\NOUT\\Soap\\StructType\\DisplayUndoMessageResponse',
            'GetContentFolder' => '\\NOUT\\Soap\\StructType\\GetContentFolder',
            'GetContentFolderResponse' => '\\NOUT\\Soap\\StructType\\GetContentFolderResponse',
            'GetFolderListResponse' => '\\NOUT\\Soap\\StructType\\GetFolderListResponse',
            'GetListIDMessFromFolder' => '\\NOUT\\Soap\\StructType\\GetListIDMessFromFolder',
            'GetListIDMessFromFolderResponse' => '\\NOUT\\Soap\\StructType\\GetListIDMessFromFolderResponse',
            'GetListIDMessFromRequest' => '\\NOUT\\Soap\\StructType\\GetListIDMessFromRequest',
            'GetListIDMessFromRequestResponse' => '\\NOUT\\Soap\\StructType\\GetListIDMessFromRequestResponse',
            'GetListMessage' => '\\NOUT\\Soap\\StructType\\GetListMessage',
            'GetListMessageResponse' => '\\NOUT\\Soap\\StructType\\GetListMessageResponse',
            'LastUnReadType' => '\\NOUT\\Soap\\StructType\\LastUnReadType',
            'GetMailServiceStatusResponse' => '\\NOUT\\Soap\\StructType\\GetMailServiceStatusResponse',
            'GetMessagesFromListID' => '\\NOUT\\Soap\\StructType\\GetMessagesFromListID',
            'GetMessagesFromListIDResponse' => '\\NOUT\\Soap\\StructType\\GetMessagesFromListIDResponse',
            'GetPJResponseType' => '\\NOUT\\Soap\\StructType\\GetPJResponseType',
            'GetPJ' => '\\NOUT\\Soap\\StructType\\GetPJ',
            'GetPJResponse' => '\\NOUT\\Soap\\StructType\\GetPJResponse',
            'GetRedoList' => '\\NOUT\\Soap\\StructType\\GetRedoList',
            'GetRedoListResponse' => '\\NOUT\\Soap\\StructType\\GetRedoListResponse',
            'GetRedoListID' => '\\NOUT\\Soap\\StructType\\GetRedoListID',
            'GetRedoListIDResponse' => '\\NOUT\\Soap\\StructType\\GetRedoListIDResponse',
            'GetUndoList' => '\\NOUT\\Soap\\StructType\\GetUndoList',
            'GetUndoListResponse' => '\\NOUT\\Soap\\StructType\\GetUndoListResponse',
            'GetUndoListID' => '\\NOUT\\Soap\\StructType\\GetUndoListID',
            'GetUndoListIDResponse' => '\\NOUT\\Soap\\StructType\\GetUndoListIDResponse',
            'ModifyFolder' => '\\NOUT\\Soap\\StructType\\ModifyFolder',
            'ModifyFolderResponse' => '\\NOUT\\Soap\\StructType\\ModifyFolderResponse',
            'ModifyMessage' => '\\NOUT\\Soap\\StructType\\ModifyMessage',
            'ModifyMessageResponse' => '\\NOUT\\Soap\\StructType\\ModifyMessageResponse',
            'Redo' => '\\NOUT\\Soap\\StructType\\Redo',
            'RedoResponse' => '\\NOUT\\Soap\\StructType\\RedoResponse',
            'RequestMessage' => '\\NOUT\\Soap\\StructType\\RequestMessage',
            'RequestMessageResponse' => '\\NOUT\\Soap\\StructType\\RequestMessageResponse',
            'SendMessage' => '\\NOUT\\Soap\\StructType\\SendMessage',
            'SendMessageResponse' => '\\NOUT\\Soap\\StructType\\SendMessageResponse',
            'Undo' => '\\NOUT\\Soap\\StructType\\Undo',
            'UndoResponse' => '\\NOUT\\Soap\\StructType\\UndoResponse',
            'UpdateColumnMessageValueInBatch' => '\\NOUT\\Soap\\StructType\\UpdateColumnMessageValueInBatch',
            'UpdateColumnMessageValueInBatchResponse' => '\\NOUT\\Soap\\StructType\\UpdateColumnMessageValueInBatchResponse',
            'UpdateFolder' => '\\NOUT\\Soap\\StructType\\UpdateFolder',
            'UpdateFolderResponse' => '\\NOUT\\Soap\\StructType\\UpdateFolderResponse',
            'UpdateMessage' => '\\NOUT\\Soap\\StructType\\UpdateMessage',
            'UpdateMessageResponse' => '\\NOUT\\Soap\\StructType\\UpdateMessageResponse',
            'ValidateFolder' => '\\NOUT\\Soap\\StructType\\ValidateFolder',
            'WithAutomaticResponse' => '\\NOUT\\Soap\\StructType\\WithAutomaticResponse',
            'WithAutomaticResponseResponse' => '\\NOUT\\Soap\\StructType\\WithAutomaticResponseResponse',
            'ZipPJ' => '\\NOUT\\Soap\\StructType\\ZipPJ',
            'ZipPJResponse' => '\\NOUT\\Soap\\StructType\\ZipPJResponse',
        ];
    }
}
