<?php

declare(strict_types=1);

namespace NOUT\Soap\EnumType;

use NOUT\Soap\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for CalculationTypeEnum EnumType
 * @subpackage Enumerations
 */
class CalculationTypeEnum extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Sum'
     * @return string 'Sum'
     */
    const VALUE_SUM = 'Sum';
    /**
     * Constant for value 'Count'
     * @return string 'Count'
     */
    const VALUE_COUNT = 'Count';
    /**
     * Constant for value 'Max'
     * @return string 'Max'
     */
    const VALUE_MAX = 'Max';
    /**
     * Constant for value 'Min'
     * @return string 'Min'
     */
    const VALUE_MIN = 'Min';
    /**
     * Constant for value 'Average'
     * @return string 'Average'
     */
    const VALUE_AVERAGE = 'Average';
    /**
     * Return allowed values
     * @uses self::VALUE_SUM
     * @uses self::VALUE_COUNT
     * @uses self::VALUE_MAX
     * @uses self::VALUE_MIN
     * @uses self::VALUE_AVERAGE
     * @return string[]
     */
    public static function getValidValues(): array
    {
        return [
            self::VALUE_SUM,
            self::VALUE_COUNT,
            self::VALUE_MAX,
            self::VALUE_MIN,
            self::VALUE_AVERAGE,
        ];
    }
}
