<?php

declare(strict_types=1);

namespace NOUT\Soap\EnumType;

use NOUT\Soap\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for DisplayModeEnum EnumType
 * @subpackage Enumerations
 */
class DisplayModeEnum extends AbstractStructEnumBase
{
    /**
     * Constant for value 'List'
     * @return string 'List'
     */
    const VALUE_LIST = 'List';
    /**
     * Constant for value 'Chart'
     * @return string 'Chart'
     */
    const VALUE_CHART = 'Chart';
    /**
     * Constant for value 'Planning'
     * @return string 'Planning'
     */
    const VALUE_PLANNING = 'Planning';
    /**
     * Constant for value 'Thumbnail'
     * @return string 'Thumbnail'
     */
    const VALUE_THUMBNAIL = 'Thumbnail';
    /**
     * Return allowed values
     * @uses self::VALUE_LIST
     * @uses self::VALUE_CHART
     * @uses self::VALUE_PLANNING
     * @uses self::VALUE_THUMBNAIL
     * @return string[]
     */
    public static function getValidValues(): array
    {
        return [
            self::VALUE_LIST,
            self::VALUE_CHART,
            self::VALUE_PLANNING,
            self::VALUE_THUMBNAIL,
        ];
    }
}
