<?php

declare(strict_types=1);

namespace NOUT\Soap\EnumType;

use NOUT\Soap\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for StateEnum EnumType
 * @subpackage Enumerations
 */
class StateEnum extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Processed'
     * @return string 'Processed'
     */
    const VALUE_PROCESSED = 'Processed';
    /**
     * Constant for value 'Unprocessed'
     * @return string 'Unprocessed'
     */
    const VALUE_UNPROCESSED = 'Unprocessed';
    /**
     * Constant for value 'All'
     * @return string 'All'
     */
    const VALUE_ALL = 'All';
    /**
     * Return allowed values
     * @uses self::VALUE_PROCESSED
     * @uses self::VALUE_UNPROCESSED
     * @uses self::VALUE_ALL
     * @return string[]
     */
    public static function getValidValues(): array
    {
        return [
            self::VALUE_PROCESSED,
            self::VALUE_UNPROCESSED,
            self::VALUE_ALL,
        ];
    }
}
