<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for AddPJ StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class AddPJ extends AbstractStructBase
{
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The DataPJ
     * @var \NOUT\Soap\StructType\DataType|null
     */
    protected ?\NOUT\Soap\StructType\DataType $DataPJ = null;
    /**
     * Constructor method for AddPJ
     * @uses AddPJ::setIDMessage()
     * @uses AddPJ::setDataPJ()
     * @param string $iDMessage
     * @param \NOUT\Soap\StructType\DataType $dataPJ
     */
    public function __construct(?string $iDMessage = null, ?\NOUT\Soap\StructType\DataType $dataPJ = null)
    {
        $this
            ->setIDMessage($iDMessage)
            ->setDataPJ($dataPJ);
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\AddPJ
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get DataPJ value
     * @return \NOUT\Soap\StructType\DataType|null
     */
    public function getDataPJ(): ?\NOUT\Soap\StructType\DataType
    {
        return $this->DataPJ;
    }
    /**
     * Set DataPJ value
     * @param \NOUT\Soap\StructType\DataType $dataPJ
     * @return \NOUT\Soap\StructType\AddPJ
     */
    public function setDataPJ(?\NOUT\Soap\StructType\DataType $dataPJ = null): self
    {
        $this->DataPJ = $dataPJ;
        
        return $this;
    }
}
