<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for AutoComplete StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class AutoComplete extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The AutoComplete
     * @var string|null
     */
    protected ?string $AutoComplete = null;
    /**
     * The MaxResult
     * @var int|null
     */
    protected ?int $MaxResult = null;
    /**
     * Constructor method for AutoComplete
     * @uses AutoComplete::setTable()
     * @uses AutoComplete::setAutoComplete()
     * @uses AutoComplete::setMaxResult()
     * @param string $table
     * @param string $autoComplete
     * @param int $maxResult
     */
    public function __construct(?string $table = null, ?string $autoComplete = null, ?int $maxResult = null)
    {
        $this
            ->setTable($table)
            ->setAutoComplete($autoComplete)
            ->setMaxResult($maxResult);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\AutoComplete
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get AutoComplete value
     * @return string|null
     */
    public function getAutoComplete(): ?string
    {
        return $this->AutoComplete;
    }
    /**
     * Set AutoComplete value
     * @param string $autoComplete
     * @return \NOUT\Soap\StructType\AutoComplete
     */
    public function setAutoComplete(?string $autoComplete = null): self
    {
        // validation for constraint: string
        if (!is_null($autoComplete) && !is_string($autoComplete)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($autoComplete, true), gettype($autoComplete)), __LINE__);
        }
        $this->AutoComplete = $autoComplete;
        
        return $this;
    }
    /**
     * Get MaxResult value
     * @return int|null
     */
    public function getMaxResult(): ?int
    {
        return $this->MaxResult;
    }
    /**
     * Set MaxResult value
     * @param int $maxResult
     * @return \NOUT\Soap\StructType\AutoComplete
     */
    public function setMaxResult(?int $maxResult = null): self
    {
        // validation for constraint: int
        if (!is_null($maxResult) && !(is_int($maxResult) || ctype_digit($maxResult))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxResult, true), gettype($maxResult)), __LINE__);
        }
        $this->MaxResult = $maxResult;
        
        return $this;
    }
}
