<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for CalculationListType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class CalculationListType extends AbstractStructBase
{
    /**
     * The Calculation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    protected ?array $Calculation = null;
    /**
     * Constructor method for CalculationListType
     * @uses CalculationListType::setCalculation()
     * @param string[] $calculation
     */
    public function __construct(?array $calculation = null)
    {
        $this
            ->setCalculation($calculation);
    }
    /**
     * Get Calculation value
     * @return string[]
     */
    public function getCalculation(): ?array
    {
        return $this->Calculation;
    }
    /**
     * This method is responsible for validating the value(s) passed to the setCalculation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCalculation method
     * This has to validate that each item contained by the array match the itemType constraint
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCalculationForArrayConstraintFromSetCalculation(?array $values = []): string
    {
        if (!is_array($values)) {
            return '';
        }
        $message = '';
        $invalidValues = [];
        foreach ($values as $calculationListTypeCalculationItem) {
            // validation for constraint: itemType
            if (!is_string($calculationListTypeCalculationItem)) {
                $invalidValues[] = is_object($calculationListTypeCalculationItem) ? get_class($calculationListTypeCalculationItem) : sprintf('%s(%s)', gettype($calculationListTypeCalculationItem), var_export($calculationListTypeCalculationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Calculation property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        
        return $message;
    }
    /**
     * Set Calculation value
     * @throws InvalidArgumentException
     * @param string[] $calculation
     * @return \NOUT\Soap\StructType\CalculationListType
     */
    public function setCalculation(?array $calculation = null): self
    {
        // validation for constraint: array
        if ('' !== ($calculationArrayErrorMessage = self::validateCalculationForArrayConstraintFromSetCalculation($calculation))) {
            throw new InvalidArgumentException($calculationArrayErrorMessage, __LINE__);
        }
        $this->Calculation = $calculation;
        
        return $this;
    }
    /**
     * Add item to Calculation value
     * @throws InvalidArgumentException
     * @param string $item
     * @return \NOUT\Soap\StructType\CalculationListType
     */
    public function addToCalculation(string $item): self
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new InvalidArgumentException(sprintf('The Calculation property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Calculation[] = $item;
        
        return $this;
    }
}
