<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckCtrl StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class CheckCtrl extends AbstractStructBase
{
    /**
     * The CtrlType
     * @var string|null
     */
    protected ?string $CtrlType = null;
    /**
     * Constructor method for CheckCtrl
     * @uses CheckCtrl::setCtrlType()
     * @param string $ctrlType
     */
    public function __construct(?string $ctrlType = null)
    {
        $this
            ->setCtrlType($ctrlType);
    }
    /**
     * Get CtrlType value
     * @return string|null
     */
    public function getCtrlType(): ?string
    {
        return $this->CtrlType;
    }
    /**
     * Set CtrlType value
     * @param string $ctrlType
     * @return \NOUT\Soap\StructType\CheckCtrl
     */
    public function setCtrlType(?string $ctrlType = null): self
    {
        // validation for constraint: string
        if (!is_null($ctrlType) && !is_string($ctrlType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ctrlType, true), gettype($ctrlType)), __LINE__);
        }
        $this->CtrlType = $ctrlType;
        
        return $this;
    }
}
