<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for CloseFolderList StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class CloseFolderList extends AbstractStructBase
{
    /**
     * The IDList
     * @var string|null
     */
    protected ?string $IDList = null;
    /**
     * Constructor method for CloseFolderList
     * @uses CloseFolderList::setIDList()
     * @param string $iDList
     */
    public function __construct(?string $iDList = null)
    {
        $this
            ->setIDList($iDList);
    }
    /**
     * Get IDList value
     * @return string|null
     */
    public function getIDList(): ?string
    {
        return $this->IDList;
    }
    /**
     * Set IDList value
     * @param string $iDList
     * @return \NOUT\Soap\StructType\CloseFolderList
     */
    public function setIDList(?string $iDList = null): self
    {
        // validation for constraint: string
        if (!is_null($iDList) && !is_string($iDList)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDList, true), gettype($iDList)), __LINE__);
        }
        $this->IDList = $iDList;
        
        return $this;
    }
}
