<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ColumnSelection StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ColumnSelection extends AbstractStructBase
{
    /**
     * The Column
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The items
     * @var string|null
     */
    protected ?string $items = null;
    /**
     * Constructor method for ColumnSelection
     * @uses ColumnSelection::setColumn()
     * @uses ColumnSelection::setItems()
     * @param string $column
     * @param string $items
     */
    public function __construct(?string $column = null, ?string $items = null)
    {
        $this
            ->setColumn($column)
            ->setItems($items);
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\ColumnSelection
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get items value
     * @return string|null
     */
    public function getItems(): ?string
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param string $items
     * @return \NOUT\Soap\StructType\ColumnSelection
     */
    public function setItems(?string $items = null): self
    {
        // validation for constraint: string
        if (!is_null($items) && !is_string($items)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($items, true), gettype($items)), __LINE__);
        }
        $this->items = $items;
        
        return $this;
    }
}
