<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ConnectedExtranet StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ConnectedExtranet extends AbstractStructBase
{
    /**
     * The Form
     * @var string|null
     */
    protected ?string $Form = null;
    /**
     * The Element
     * @var string|null
     */
    protected ?string $Element = null;
    /**
     * Constructor method for ConnectedExtranet
     * @uses ConnectedExtranet::setForm()
     * @uses ConnectedExtranet::setElement()
     * @param string $form
     * @param string $element
     */
    public function __construct(?string $form = null, ?string $element = null)
    {
        $this
            ->setForm($form)
            ->setElement($element);
    }
    /**
     * Get Form value
     * @return string|null
     */
    public function getForm(): ?string
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param string $form
     * @return \NOUT\Soap\StructType\ConnectedExtranet
     */
    public function setForm(?string $form = null): self
    {
        // validation for constraint: string
        if (!is_null($form) && !is_string($form)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($form, true), gettype($form)), __LINE__);
        }
        $this->Form = $form;
        
        return $this;
    }
    /**
     * Get Element value
     * @return string|null
     */
    public function getElement(): ?string
    {
        return $this->Element;
    }
    /**
     * Set Element value
     * @param string $element
     * @return \NOUT\Soap\StructType\ConnectedExtranet
     */
    public function setElement(?string $element = null): self
    {
        // validation for constraint: string
        if (!is_null($element) && !is_string($element)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($element, true), gettype($element)), __LINE__);
        }
        $this->Element = $element;
        
        return $this;
    }
}
