<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Copy StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Copy extends AbstractStructBase
{
    /**
     * The items
     * @var string|null
     */
    protected ?string $items = null;
    /**
     * Constructor method for Copy
     * @uses Copy::setItems()
     * @param string $items
     */
    public function __construct(?string $items = null)
    {
        $this
            ->setItems($items);
    }
    /**
     * Get items value
     * @return string|null
     */
    public function getItems(): ?string
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param string $items
     * @return \NOUT\Soap\StructType\Copy
     */
    public function setItems(?string $items = null): self
    {
        // validation for constraint: string
        if (!is_null($items) && !is_string($items)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($items, true), gettype($items)), __LINE__);
        }
        $this->items = $items;
        
        return $this;
    }
}
