<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Count StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Count extends AbstractStructBase
{
    /**
     * The NbFiltered
     * @var int|null
     */
    protected ?int $NbFiltered = null;
    /**
     * The NbTotal
     * @var int|null
     */
    protected ?int $NbTotal = null;
    /**
     * The NbCalculation
     * @var int|null
     */
    protected ?int $NbCalculation = null;
    /**
     * The NbLine
     * @var int|null
     */
    protected ?int $NbLine = null;
    /**
     * Constructor method for Count
     * @uses Count::setNbFiltered()
     * @uses Count::setNbTotal()
     * @uses Count::setNbCalculation()
     * @uses Count::setNbLine()
     * @param int $nbFiltered
     * @param int $nbTotal
     * @param int $nbCalculation
     * @param int $nbLine
     */
    public function __construct(?int $nbFiltered = null, ?int $nbTotal = null, ?int $nbCalculation = null, ?int $nbLine = null)
    {
        $this
            ->setNbFiltered($nbFiltered)
            ->setNbTotal($nbTotal)
            ->setNbCalculation($nbCalculation)
            ->setNbLine($nbLine);
    }
    /**
     * Get NbFiltered value
     * @return int|null
     */
    public function getNbFiltered(): ?int
    {
        return $this->NbFiltered;
    }
    /**
     * Set NbFiltered value
     * @param int $nbFiltered
     * @return \NOUT\Soap\StructType\Count
     */
    public function setNbFiltered(?int $nbFiltered = null): self
    {
        // validation for constraint: int
        if (!is_null($nbFiltered) && !(is_int($nbFiltered) || ctype_digit($nbFiltered))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nbFiltered, true), gettype($nbFiltered)), __LINE__);
        }
        $this->NbFiltered = $nbFiltered;
        
        return $this;
    }
    /**
     * Get NbTotal value
     * @return int|null
     */
    public function getNbTotal(): ?int
    {
        return $this->NbTotal;
    }
    /**
     * Set NbTotal value
     * @param int $nbTotal
     * @return \NOUT\Soap\StructType\Count
     */
    public function setNbTotal(?int $nbTotal = null): self
    {
        // validation for constraint: int
        if (!is_null($nbTotal) && !(is_int($nbTotal) || ctype_digit($nbTotal))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nbTotal, true), gettype($nbTotal)), __LINE__);
        }
        $this->NbTotal = $nbTotal;
        
        return $this;
    }
    /**
     * Get NbCalculation value
     * @return int|null
     */
    public function getNbCalculation(): ?int
    {
        return $this->NbCalculation;
    }
    /**
     * Set NbCalculation value
     * @param int $nbCalculation
     * @return \NOUT\Soap\StructType\Count
     */
    public function setNbCalculation(?int $nbCalculation = null): self
    {
        // validation for constraint: int
        if (!is_null($nbCalculation) && !(is_int($nbCalculation) || ctype_digit($nbCalculation))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nbCalculation, true), gettype($nbCalculation)), __LINE__);
        }
        $this->NbCalculation = $nbCalculation;
        
        return $this;
    }
    /**
     * Get NbLine value
     * @return int|null
     */
    public function getNbLine(): ?int
    {
        return $this->NbLine;
    }
    /**
     * Set NbLine value
     * @param int $nbLine
     * @return \NOUT\Soap\StructType\Count
     */
    public function setNbLine(?int $nbLine = null): self
    {
        // validation for constraint: int
        if (!is_null($nbLine) && !(is_int($nbLine) || ctype_digit($nbLine))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nbLine, true), gettype($nbLine)), __LINE__);
        }
        $this->NbLine = $nbLine;
        
        return $this;
    }
}
