<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateMessage StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class CreateMessage extends AbstractStructBase
{
    /**
     * The CreateType
     * @var string|null
     */
    protected ?string $CreateType = null;
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The IDAnswerType
     * @var string|null
     */
    protected ?string $IDAnswerType = null;
    /**
     * Constructor method for CreateMessage
     * @uses CreateMessage::setCreateType()
     * @uses CreateMessage::setIDMessage()
     * @uses CreateMessage::setIDAnswerType()
     * @param string $createType
     * @param string $iDMessage
     * @param string $iDAnswerType
     */
    public function __construct(?string $createType = null, ?string $iDMessage = null, ?string $iDAnswerType = null)
    {
        $this
            ->setCreateType($createType)
            ->setIDMessage($iDMessage)
            ->setIDAnswerType($iDAnswerType);
    }
    /**
     * Get CreateType value
     * @return string|null
     */
    public function getCreateType(): ?string
    {
        return $this->CreateType;
    }
    /**
     * Set CreateType value
     * @uses \NOUT\Soap\EnumType\CreateTypeEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\CreateTypeEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $createType
     * @return \NOUT\Soap\StructType\CreateMessage
     */
    public function setCreateType(?string $createType = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\CreateTypeEnum::valueIsValid($createType)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\CreateTypeEnum', is_array($createType) ? implode(', ', $createType) : var_export($createType, true), implode(', ', \NOUT\Soap\EnumType\CreateTypeEnum::getValidValues())), __LINE__);
        }
        $this->CreateType = $createType;
        
        return $this;
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\CreateMessage
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get IDAnswerType value
     * @return string|null
     */
    public function getIDAnswerType(): ?string
    {
        return $this->IDAnswerType;
    }
    /**
     * Set IDAnswerType value
     * @param string $iDAnswerType
     * @return \NOUT\Soap\StructType\CreateMessage
     */
    public function setIDAnswerType(?string $iDAnswerType = null): self
    {
        // validation for constraint: string
        if (!is_null($iDAnswerType) && !is_string($iDAnswerType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDAnswerType, true), gettype($iDAnswerType)), __LINE__);
        }
        $this->IDAnswerType = $iDAnswerType;
        
        return $this;
    }
}
