<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for DataType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class DataType extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The encoding
     * @var string|null
     */
    protected ?string $encoding = null;
    /**
     * The filename
     * @var string|null
     */
    protected ?string $filename = null;
    /**
     * The size
     * @var int|null
     */
    protected ?int $size = null;
    /**
     * Constructor method for DataType
     * @uses DataType::set_()
     * @uses DataType::setEncoding()
     * @uses DataType::setFilename()
     * @uses DataType::setSize()
     * @param string $_
     * @param string $encoding
     * @param string $filename
     * @param int $size
     */
    public function __construct(?string $_ = null, ?string $encoding = null, ?string $filename = null, ?int $size = null)
    {
        $this
            ->set_($_)
            ->setEncoding($encoding)
            ->setFilename($filename)
            ->setSize($size);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\DataType
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get encoding value
     * @return string|null
     */
    public function getEncoding(): ?string
    {
        return $this->encoding;
    }
    /**
     * Set encoding value
     * @param string $encoding
     * @return \NOUT\Soap\StructType\DataType
     */
    public function setEncoding(?string $encoding = null): self
    {
        // validation for constraint: string
        if (!is_null($encoding) && !is_string($encoding)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($encoding, true), gettype($encoding)), __LINE__);
        }
        $this->encoding = $encoding;
        
        return $this;
    }
    /**
     * Get filename value
     * @return string|null
     */
    public function getFilename(): ?string
    {
        return $this->filename;
    }
    /**
     * Set filename value
     * @param string $filename
     * @return \NOUT\Soap\StructType\DataType
     */
    public function setFilename(?string $filename = null): self
    {
        // validation for constraint: string
        if (!is_null($filename) && !is_string($filename)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($filename, true), gettype($filename)), __LINE__);
        }
        $this->filename = $filename;
        
        return $this;
    }
    /**
     * Get size value
     * @return int|null
     */
    public function getSize(): ?int
    {
        return $this->size;
    }
    /**
     * Set size value
     * @param int $size
     * @return \NOUT\Soap\StructType\DataType
     */
    public function setSize(?int $size = null): self
    {
        // validation for constraint: int
        if (!is_null($size) && !(is_int($size) || ctype_digit($size))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($size, true), gettype($size)), __LINE__);
        }
        $this->size = $size;
        
        return $this;
    }
}
