<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for EncryptionType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class EncryptionType extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The md5
     * @var string|null
     */
    protected ?string $md5 = null;
    /**
     * The iv
     * @var string|null
     */
    protected ?string $iv = null;
    /**
     * The ks
     * @var int|null
     */
    protected ?int $ks = null;
    /**
     * Constructor method for EncryptionType
     * @uses EncryptionType::set_()
     * @uses EncryptionType::setMd5()
     * @uses EncryptionType::setIv()
     * @uses EncryptionType::setKs()
     * @param string $_
     * @param string $md5
     * @param string $iv
     * @param int $ks
     */
    public function __construct(?string $_ = null, ?string $md5 = null, ?string $iv = null, ?int $ks = null)
    {
        $this
            ->set_($_)
            ->setMd5($md5)
            ->setIv($iv)
            ->setKs($ks);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\EncryptionType
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get md5 value
     * @return string|null
     */
    public function getMd5(): ?string
    {
        return $this->md5;
    }
    /**
     * Set md5 value
     * @param string $md5
     * @return \NOUT\Soap\StructType\EncryptionType
     */
    public function setMd5(?string $md5 = null): self
    {
        // validation for constraint: string
        if (!is_null($md5) && !is_string($md5)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($md5, true), gettype($md5)), __LINE__);
        }
        $this->md5 = $md5;
        
        return $this;
    }
    /**
     * Get iv value
     * @return string|null
     */
    public function getIv(): ?string
    {
        return $this->iv;
    }
    /**
     * Set iv value
     * @param string $iv
     * @return \NOUT\Soap\StructType\EncryptionType
     */
    public function setIv(?string $iv = null): self
    {
        // validation for constraint: string
        if (!is_null($iv) && !is_string($iv)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iv, true), gettype($iv)), __LINE__);
        }
        $this->iv = $iv;
        
        return $this;
    }
    /**
     * Get ks value
     * @return int|null
     */
    public function getKs(): ?int
    {
        return $this->ks;
    }
    /**
     * Set ks value
     * @param int $ks
     * @return \NOUT\Soap\StructType\EncryptionType
     */
    public function setKs(?int $ks = null): self
    {
        // validation for constraint: int
        if (!is_null($ks) && !(is_int($ks) || ctype_digit($ks))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ks, true), gettype($ks)), __LINE__);
        }
        $this->ks = $ks;
        
        return $this;
    }
}
