<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for EnterReorderListModeResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class EnterReorderListModeResponse extends AbstractStructBase
{
    /**
     * The Value
     * @var int|null
     */
    protected ?int $Value = null;
    /**
     * Constructor method for EnterReorderListModeResponse
     * @uses EnterReorderListModeResponse::setValue()
     * @param int $value
     */
    public function __construct(?int $value = null)
    {
        $this
            ->setValue($value);
    }
    /**
     * Get Value value
     * @return int|null
     */
    public function getValue(): ?int
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param int $value
     * @return \NOUT\Soap\StructType\EnterReorderListModeResponse
     */
    public function setValue(?int $value = null): self
    {
        // validation for constraint: int
        if (!is_null($value) && !(is_int($value) || ctype_digit($value))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        
        return $this;
    }
}
