<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ExecuteWithoutIHM StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ExecuteWithoutIHM extends AbstractStructBase
{
    /**
     * The ID
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The Sentence
     * @var string|null
     */
    protected ?string $Sentence = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The BtnListMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $BtnListMode = null;
    /**
     * The Final
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $Final = null;
    /**
     * The UpdateData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $UpdateData = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for ExecuteWithoutIHM
     * @uses ExecuteWithoutIHM::setID()
     * @uses ExecuteWithoutIHM::setSentence()
     * @uses ExecuteWithoutIHM::setParamXML()
     * @uses ExecuteWithoutIHM::setBtnListMode()
     * @uses ExecuteWithoutIHM::setFinal()
     * @uses ExecuteWithoutIHM::setUpdateData()
     * @uses ExecuteWithoutIHM::setVirtualParamList()
     * @param string $iD
     * @param string $sentence
     * @param string $paramXML
     * @param int $btnListMode
     * @param int $final
     * @param string $updateData
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $iD = null, ?string $sentence = null, ?string $paramXML = null, ?int $btnListMode = null, ?int $final = null, ?string $updateData = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setID($iD)
            ->setSentence($sentence)
            ->setParamXML($paramXML)
            ->setBtnListMode($btnListMode)
            ->setFinal($final)
            ->setUpdateData($updateData)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get Sentence value
     * @return string|null
     */
    public function getSentence(): ?string
    {
        return $this->Sentence;
    }
    /**
     * Set Sentence value
     * @param string $sentence
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setSentence(?string $sentence = null): self
    {
        // validation for constraint: string
        if (!is_null($sentence) && !is_string($sentence)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sentence, true), gettype($sentence)), __LINE__);
        }
        $this->Sentence = $sentence;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get BtnListMode value
     * @return int|null
     */
    public function getBtnListMode(): ?int
    {
        return $this->BtnListMode;
    }
    /**
     * Set BtnListMode value
     * @param int $btnListMode
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setBtnListMode(?int $btnListMode = null): self
    {
        // validation for constraint: int
        if (!is_null($btnListMode) && !(is_int($btnListMode) || ctype_digit($btnListMode))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($btnListMode, true), gettype($btnListMode)), __LINE__);
        }
        $this->BtnListMode = $btnListMode;
        
        return $this;
    }
    /**
     * Get Final value
     * @return int|null
     */
    public function getFinal(): ?int
    {
        return $this->Final;
    }
    /**
     * Set Final value
     * @param int $final
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setFinal(?int $final = null): self
    {
        // validation for constraint: int
        if (!is_null($final) && !(is_int($final) || ctype_digit($final))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($final, true), gettype($final)), __LINE__);
        }
        $this->Final = $final;
        
        return $this;
    }
    /**
     * Get UpdateData value
     * @return string|null
     */
    public function getUpdateData(): ?string
    {
        return $this->UpdateData;
    }
    /**
     * Set UpdateData value
     * @param string $updateData
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setUpdateData(?string $updateData = null): self
    {
        // validation for constraint: string
        if (!is_null($updateData) && !is_string($updateData)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateData, true), gettype($updateData)), __LINE__);
        }
        $this->UpdateData = $updateData;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\ExecuteWithoutIHM
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
