<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Export StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Export extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The Export
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Export = null;
    /**
     * The Format
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Format = null;
    /**
     * The Module
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Module = null;
    /**
     * The ColType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ColType = null;
    /**
     * The items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $items = null;
    /**
     * Constructor method for Export
     * @uses Export::setTable()
     * @uses Export::setID()
     * @uses Export::setExport()
     * @uses Export::setFormat()
     * @uses Export::setModule()
     * @uses Export::setColType()
     * @uses Export::setItems()
     * @param string $table
     * @param string $iD
     * @param string $export
     * @param string $format
     * @param string $module
     * @param string $colType
     * @param string $items
     */
    public function __construct(?string $table = null, ?string $iD = null, ?string $export = null, ?string $format = null, ?string $module = null, ?string $colType = null, ?string $items = null)
    {
        $this
            ->setTable($table)
            ->setID($iD)
            ->setExport($export)
            ->setFormat($format)
            ->setModule($module)
            ->setColType($colType)
            ->setItems($items);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\Export
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\Export
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get Export value
     * @return string|null
     */
    public function getExport(): ?string
    {
        return $this->Export;
    }
    /**
     * Set Export value
     * @param string $export
     * @return \NOUT\Soap\StructType\Export
     */
    public function setExport(?string $export = null): self
    {
        // validation for constraint: string
        if (!is_null($export) && !is_string($export)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($export, true), gettype($export)), __LINE__);
        }
        $this->Export = $export;
        
        return $this;
    }
    /**
     * Get Format value
     * @return string|null
     */
    public function getFormat(): ?string
    {
        return $this->Format;
    }
    /**
     * Set Format value
     * @param string $format
     * @return \NOUT\Soap\StructType\Export
     */
    public function setFormat(?string $format = null): self
    {
        // validation for constraint: string
        if (!is_null($format) && !is_string($format)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($format, true), gettype($format)), __LINE__);
        }
        $this->Format = $format;
        
        return $this;
    }
    /**
     * Get Module value
     * @return string|null
     */
    public function getModule(): ?string
    {
        return $this->Module;
    }
    /**
     * Set Module value
     * @param string $module
     * @return \NOUT\Soap\StructType\Export
     */
    public function setModule(?string $module = null): self
    {
        // validation for constraint: string
        if (!is_null($module) && !is_string($module)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($module, true), gettype($module)), __LINE__);
        }
        $this->Module = $module;
        
        return $this;
    }
    /**
     * Get ColType value
     * @return string|null
     */
    public function getColType(): ?string
    {
        return $this->ColType;
    }
    /**
     * Set ColType value
     * @param string $colType
     * @return \NOUT\Soap\StructType\Export
     */
    public function setColType(?string $colType = null): self
    {
        // validation for constraint: string
        if (!is_null($colType) && !is_string($colType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($colType, true), gettype($colType)), __LINE__);
        }
        $this->ColType = $colType;
        
        return $this;
    }
    /**
     * Get items value
     * @return string|null
     */
    public function getItems(): ?string
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param string $items
     * @return \NOUT\Soap\StructType\Export
     */
    public function setItems(?string $items = null): self
    {
        // validation for constraint: string
        if (!is_null($items) && !is_string($items)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($items, true), gettype($items)), __LINE__);
        }
        $this->items = $items;
        
        return $this;
    }
}
