<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Filter StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Filter extends AbstractStructBase
{
    /**
     * The xml
     * @var string|null
     */
    protected ?string $xml = null;
    /**
     * The schema
     * @var string|null
     */
    protected ?string $schema = null;
    /**
     * Constructor method for Filter
     * @uses Filter::setXml()
     * @uses Filter::setSchema()
     * @param string $xml
     * @param string $schema
     */
    public function __construct(?string $xml = null, ?string $schema = null)
    {
        $this
            ->setXml($xml)
            ->setSchema($schema);
    }
    /**
     * Get xml value
     * @return string|null
     */
    public function getXml(): ?string
    {
        return $this->xml;
    }
    /**
     * Set xml value
     * @param string $xml
     * @return \NOUT\Soap\StructType\Filter
     */
    public function setXml(?string $xml = null): self
    {
        // validation for constraint: string
        if (!is_null($xml) && !is_string($xml)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xml, true), gettype($xml)), __LINE__);
        }
        $this->xml = $xml;
        
        return $this;
    }
    /**
     * Get schema value
     * @return string|null
     */
    public function getSchema(): ?string
    {
        return $this->schema;
    }
    /**
     * Set schema value
     * @param string $schema
     * @return \NOUT\Soap\StructType\Filter
     */
    public function setSchema(?string $schema = null): self
    {
        // validation for constraint: string
        if (!is_null($schema) && !is_string($schema)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($schema, true), gettype($schema)), __LINE__);
        }
        $this->schema = $schema;
        
        return $this;
    }
}
