<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for FilterType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class FilterType extends AbstractStructBase
{
    /**
     * The Way
     * @var string|null
     */
    protected ?string $Way = null;
    /**
     * The State
     * @var string|null
     */
    protected ?string $State = null;
    /**
     * The Inner
     * @var int|null
     */
    protected ?int $Inner = null;
    /**
     * The Email
     * @var int|null
     */
    protected ?int $Email = null;
    /**
     * The Spam
     * @var int|null
     */
    protected ?int $Spam = null;
    /**
     * The Max
     * @var int|null
     */
    protected ?int $Max = null;
    /**
     * The From
     * @var string|null
     */
    protected ?string $From = null;
    /**
     * The Containing
     * @var string|null
     */
    protected ?string $Containing = null;
    /**
     * Constructor method for FilterType
     * @uses FilterType::setWay()
     * @uses FilterType::setState()
     * @uses FilterType::setInner()
     * @uses FilterType::setEmail()
     * @uses FilterType::setSpam()
     * @uses FilterType::setMax()
     * @uses FilterType::setFrom()
     * @uses FilterType::setContaining()
     * @param string $way
     * @param string $state
     * @param int $inner
     * @param int $email
     * @param int $spam
     * @param int $max
     * @param string $from
     * @param string $containing
     */
    public function __construct(?string $way = null, ?string $state = null, ?int $inner = null, ?int $email = null, ?int $spam = null, ?int $max = null, ?string $from = null, ?string $containing = null)
    {
        $this
            ->setWay($way)
            ->setState($state)
            ->setInner($inner)
            ->setEmail($email)
            ->setSpam($spam)
            ->setMax($max)
            ->setFrom($from)
            ->setContaining($containing);
    }
    /**
     * Get Way value
     * @return string|null
     */
    public function getWay(): ?string
    {
        return $this->Way;
    }
    /**
     * Set Way value
     * @uses \NOUT\Soap\EnumType\WayEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\WayEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $way
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setWay(?string $way = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\WayEnum::valueIsValid($way)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\WayEnum', is_array($way) ? implode(', ', $way) : var_export($way, true), implode(', ', \NOUT\Soap\EnumType\WayEnum::getValidValues())), __LINE__);
        }
        $this->Way = $way;
        
        return $this;
    }
    /**
     * Get State value
     * @return string|null
     */
    public function getState(): ?string
    {
        return $this->State;
    }
    /**
     * Set State value
     * @uses \NOUT\Soap\EnumType\StateEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\StateEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $state
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setState(?string $state = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\StateEnum::valueIsValid($state)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\StateEnum', is_array($state) ? implode(', ', $state) : var_export($state, true), implode(', ', \NOUT\Soap\EnumType\StateEnum::getValidValues())), __LINE__);
        }
        $this->State = $state;
        
        return $this;
    }
    /**
     * Get Inner value
     * @return int|null
     */
    public function getInner(): ?int
    {
        return $this->Inner;
    }
    /**
     * Set Inner value
     * @param int $inner
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setInner(?int $inner = null): self
    {
        // validation for constraint: int
        if (!is_null($inner) && !(is_int($inner) || ctype_digit($inner))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($inner, true), gettype($inner)), __LINE__);
        }
        $this->Inner = $inner;
        
        return $this;
    }
    /**
     * Get Email value
     * @return int|null
     */
    public function getEmail(): ?int
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param int $email
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setEmail(?int $email = null): self
    {
        // validation for constraint: int
        if (!is_null($email) && !(is_int($email) || ctype_digit($email))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        
        return $this;
    }
    /**
     * Get Spam value
     * @return int|null
     */
    public function getSpam(): ?int
    {
        return $this->Spam;
    }
    /**
     * Set Spam value
     * @param int $spam
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setSpam(?int $spam = null): self
    {
        // validation for constraint: int
        if (!is_null($spam) && !(is_int($spam) || ctype_digit($spam))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($spam, true), gettype($spam)), __LINE__);
        }
        $this->Spam = $spam;
        
        return $this;
    }
    /**
     * Get Max value
     * @return int|null
     */
    public function getMax(): ?int
    {
        return $this->Max;
    }
    /**
     * Set Max value
     * @param int $max
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setMax(?int $max = null): self
    {
        // validation for constraint: int
        if (!is_null($max) && !(is_int($max) || ctype_digit($max))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($max, true), gettype($max)), __LINE__);
        }
        $this->Max = $max;
        
        return $this;
    }
    /**
     * Get From value
     * @return string|null
     */
    public function getFrom(): ?string
    {
        return $this->From;
    }
    /**
     * Set From value
     * @param string $from
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setFrom(?string $from = null): self
    {
        // validation for constraint: string
        if (!is_null($from) && !is_string($from)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($from, true), gettype($from)), __LINE__);
        }
        $this->From = $from;
        
        return $this;
    }
    /**
     * Get Containing value
     * @return string|null
     */
    public function getContaining(): ?string
    {
        return $this->Containing;
    }
    /**
     * Set Containing value
     * @param string $containing
     * @return \NOUT\Soap\StructType\FilterType
     */
    public function setContaining(?string $containing = null): self
    {
        // validation for constraint: string
        if (!is_null($containing) && !is_string($containing)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($containing, true), gettype($containing)), __LINE__);
        }
        $this->Containing = $containing;
        
        return $this;
    }
}
