<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for FolderCount StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class FolderCount extends AbstractStructBase
{
    /**
     * The NbUnRead
     * @var int|null
     */
    protected ?int $NbUnRead = null;
    /**
     * The NbReceive
     * @var int|null
     */
    protected ?int $NbReceive = null;
    /**
     * Constructor method for FolderCount
     * @uses FolderCount::setNbUnRead()
     * @uses FolderCount::setNbReceive()
     * @param int $nbUnRead
     * @param int $nbReceive
     */
    public function __construct(?int $nbUnRead = null, ?int $nbReceive = null)
    {
        $this
            ->setNbUnRead($nbUnRead)
            ->setNbReceive($nbReceive);
    }
    /**
     * Get NbUnRead value
     * @return int|null
     */
    public function getNbUnRead(): ?int
    {
        return $this->NbUnRead;
    }
    /**
     * Set NbUnRead value
     * @param int $nbUnRead
     * @return \NOUT\Soap\StructType\FolderCount
     */
    public function setNbUnRead(?int $nbUnRead = null): self
    {
        // validation for constraint: int
        if (!is_null($nbUnRead) && !(is_int($nbUnRead) || ctype_digit($nbUnRead))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nbUnRead, true), gettype($nbUnRead)), __LINE__);
        }
        $this->NbUnRead = $nbUnRead;
        
        return $this;
    }
    /**
     * Get NbReceive value
     * @return int|null
     */
    public function getNbReceive(): ?int
    {
        return $this->NbReceive;
    }
    /**
     * Set NbReceive value
     * @param int $nbReceive
     * @return \NOUT\Soap\StructType\FolderCount
     */
    public function setNbReceive(?int $nbReceive = null): self
    {
        // validation for constraint: int
        if (!is_null($nbReceive) && !(is_int($nbReceive) || ctype_digit($nbReceive))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nbReceive, true), gettype($nbReceive)), __LINE__);
        }
        $this->NbReceive = $nbReceive;
        
        return $this;
    }
}
