<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for FormElement StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class FormElement extends AbstractStructBase
{
    /**
     * The Form
     * @var \NOUT\Soap\StructType\Form|null
     */
    protected ?\NOUT\Soap\StructType\Form $Form = null;
    /**
     * The Element
     * @var \NOUT\Soap\StructType\Element|null
     */
    protected ?\NOUT\Soap\StructType\Element $Element = null;
    /**
     * Constructor method for FormElement
     * @uses FormElement::setForm()
     * @uses FormElement::setElement()
     * @param \NOUT\Soap\StructType\Form $form
     * @param \NOUT\Soap\StructType\Element $element
     */
    public function __construct(?\NOUT\Soap\StructType\Form $form = null, ?\NOUT\Soap\StructType\Element $element = null)
    {
        $this
            ->setForm($form)
            ->setElement($element);
    }
    /**
     * Get Form value
     * @return \NOUT\Soap\StructType\Form|null
     */
    public function getForm(): ?\NOUT\Soap\StructType\Form
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param \NOUT\Soap\StructType\Form $form
     * @return \NOUT\Soap\StructType\FormElement
     */
    public function setForm(?\NOUT\Soap\StructType\Form $form = null): self
    {
        $this->Form = $form;
        
        return $this;
    }
    /**
     * Get Element value
     * @return \NOUT\Soap\StructType\Element|null
     */
    public function getElement(): ?\NOUT\Soap\StructType\Element
    {
        return $this->Element;
    }
    /**
     * Set Element value
     * @param \NOUT\Soap\StructType\Element $element
     * @return \NOUT\Soap\StructType\FormElement
     */
    public function setElement(?\NOUT\Soap\StructType\Element $element = null): self
    {
        $this->Element = $element;
        
        return $this;
    }
}
