<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCalculation StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetCalculation extends AbstractStructBase
{
    /**
     * The ColList
     * @var \NOUT\Soap\StructType\ColListType|null
     */
    protected ?\NOUT\Soap\StructType\ColListType $ColList = null;
    /**
     * The CalculationList
     * @var \NOUT\Soap\StructType\CalculationListType|null
     */
    protected ?\NOUT\Soap\StructType\CalculationListType $CalculationList = null;
    /**
     * Constructor method for GetCalculation
     * @uses GetCalculation::setColList()
     * @uses GetCalculation::setCalculationList()
     * @param \NOUT\Soap\StructType\ColListType $colList
     * @param \NOUT\Soap\StructType\CalculationListType $calculationList
     */
    public function __construct(?\NOUT\Soap\StructType\ColListType $colList = null, ?\NOUT\Soap\StructType\CalculationListType $calculationList = null)
    {
        $this
            ->setColList($colList)
            ->setCalculationList($calculationList);
    }
    /**
     * Get ColList value
     * @return \NOUT\Soap\StructType\ColListType|null
     */
    public function getColList(): ?\NOUT\Soap\StructType\ColListType
    {
        return $this->ColList;
    }
    /**
     * Set ColList value
     * @param \NOUT\Soap\StructType\ColListType $colList
     * @return \NOUT\Soap\StructType\GetCalculation
     */
    public function setColList(?\NOUT\Soap\StructType\ColListType $colList = null): self
    {
        $this->ColList = $colList;
        
        return $this;
    }
    /**
     * Get CalculationList value
     * @return \NOUT\Soap\StructType\CalculationListType|null
     */
    public function getCalculationList(): ?\NOUT\Soap\StructType\CalculationListType
    {
        return $this->CalculationList;
    }
    /**
     * Set CalculationList value
     * @param \NOUT\Soap\StructType\CalculationListType $calculationList
     * @return \NOUT\Soap\StructType\GetCalculation
     */
    public function setCalculationList(?\NOUT\Soap\StructType\CalculationListType $calculationList = null): self
    {
        $this->CalculationList = $calculationList;
        
        return $this;
    }
}
