<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetChart StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetChart extends AbstractStructBase
{
    /**
     * The Height
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $Height = null;
    /**
     * The Width
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $Width = null;
    /**
     * The DPI
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $DPI = null;
    /**
     * The Index
     * @var int|null
     */
    protected ?int $Index = null;
    /**
     * The ParamXML
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The Axes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Axes = null;
    /**
     * The Calculation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Calculation = null;
    /**
     * The OnlyData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $OnlyData = null;
    /**
     * The Column
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The Record
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Record = null;
    /**
     * The ChartType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ChartType = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for GetChart
     * @uses GetChart::setHeight()
     * @uses GetChart::setWidth()
     * @uses GetChart::setDPI()
     * @uses GetChart::setIndex()
     * @uses GetChart::setParamXML()
     * @uses GetChart::setTable()
     * @uses GetChart::setAxes()
     * @uses GetChart::setCalculation()
     * @uses GetChart::setOnlyData()
     * @uses GetChart::setColumn()
     * @uses GetChart::setRecord()
     * @uses GetChart::setChartType()
     * @uses GetChart::setVirtualParamList()
     * @param int $height
     * @param int $width
     * @param int $dPI
     * @param int $index
     * @param string $paramXML
     * @param string $table
     * @param string $axes
     * @param string $calculation
     * @param int $onlyData
     * @param string $column
     * @param string $record
     * @param string $chartType
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?int $height = null, ?int $width = null, ?int $dPI = null, ?int $index = null, ?string $paramXML = null, ?string $table = null, ?string $axes = null, ?string $calculation = null, ?int $onlyData = null, ?string $column = null, ?string $record = null, ?string $chartType = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setHeight($height)
            ->setWidth($width)
            ->setDPI($dPI)
            ->setIndex($index)
            ->setParamXML($paramXML)
            ->setTable($table)
            ->setAxes($axes)
            ->setCalculation($calculation)
            ->setOnlyData($onlyData)
            ->setColumn($column)
            ->setRecord($record)
            ->setChartType($chartType)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get Height value
     * @return int|null
     */
    public function getHeight(): ?int
    {
        return $this->Height;
    }
    /**
     * Set Height value
     * @param int $height
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setHeight(?int $height = null): self
    {
        // validation for constraint: int
        if (!is_null($height) && !(is_int($height) || ctype_digit($height))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($height, true), gettype($height)), __LINE__);
        }
        $this->Height = $height;
        
        return $this;
    }
    /**
     * Get Width value
     * @return int|null
     */
    public function getWidth(): ?int
    {
        return $this->Width;
    }
    /**
     * Set Width value
     * @param int $width
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setWidth(?int $width = null): self
    {
        // validation for constraint: int
        if (!is_null($width) && !(is_int($width) || ctype_digit($width))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($width, true), gettype($width)), __LINE__);
        }
        $this->Width = $width;
        
        return $this;
    }
    /**
     * Get DPI value
     * @return int|null
     */
    public function getDPI(): ?int
    {
        return $this->DPI;
    }
    /**
     * Set DPI value
     * @param int $dPI
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setDPI(?int $dPI = null): self
    {
        // validation for constraint: int
        if (!is_null($dPI) && !(is_int($dPI) || ctype_digit($dPI))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dPI, true), gettype($dPI)), __LINE__);
        }
        $this->DPI = $dPI;
        
        return $this;
    }
    /**
     * Get Index value
     * @return int|null
     */
    public function getIndex(): ?int
    {
        return $this->Index;
    }
    /**
     * Set Index value
     * @param int $index
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setIndex(?int $index = null): self
    {
        // validation for constraint: int
        if (!is_null($index) && !(is_int($index) || ctype_digit($index))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($index, true), gettype($index)), __LINE__);
        }
        $this->Index = $index;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get Axes value
     * @return string|null
     */
    public function getAxes(): ?string
    {
        return $this->Axes;
    }
    /**
     * Set Axes value
     * @param string $axes
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setAxes(?string $axes = null): self
    {
        // validation for constraint: string
        if (!is_null($axes) && !is_string($axes)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($axes, true), gettype($axes)), __LINE__);
        }
        $this->Axes = $axes;
        
        return $this;
    }
    /**
     * Get Calculation value
     * @return string|null
     */
    public function getCalculation(): ?string
    {
        return $this->Calculation;
    }
    /**
     * Set Calculation value
     * @uses \NOUT\Soap\EnumType\CalculationTypeEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\CalculationTypeEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $calculation
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setCalculation(?string $calculation = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\CalculationTypeEnum::valueIsValid($calculation)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\CalculationTypeEnum', is_array($calculation) ? implode(', ', $calculation) : var_export($calculation, true), implode(', ', \NOUT\Soap\EnumType\CalculationTypeEnum::getValidValues())), __LINE__);
        }
        $this->Calculation = $calculation;
        
        return $this;
    }
    /**
     * Get OnlyData value
     * @return int|null
     */
    public function getOnlyData(): ?int
    {
        return $this->OnlyData;
    }
    /**
     * Set OnlyData value
     * @param int $onlyData
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setOnlyData(?int $onlyData = null): self
    {
        // validation for constraint: int
        if (!is_null($onlyData) && !(is_int($onlyData) || ctype_digit($onlyData))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($onlyData, true), gettype($onlyData)), __LINE__);
        }
        $this->OnlyData = $onlyData;
        
        return $this;
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get Record value
     * @return string|null
     */
    public function getRecord(): ?string
    {
        return $this->Record;
    }
    /**
     * Set Record value
     * @param string $record
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setRecord(?string $record = null): self
    {
        // validation for constraint: string
        if (!is_null($record) && !is_string($record)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($record, true), gettype($record)), __LINE__);
        }
        $this->Record = $record;
        
        return $this;
    }
    /**
     * Get ChartType value
     * @return string|null
     */
    public function getChartType(): ?string
    {
        return $this->ChartType;
    }
    /**
     * Set ChartType value
     * @uses \NOUT\Soap\EnumType\ChartTypeEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\ChartTypeEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $chartType
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setChartType(?string $chartType = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\ChartTypeEnum::valueIsValid($chartType)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\ChartTypeEnum', is_array($chartType) ? implode(', ', $chartType) : var_export($chartType, true), implode(', ', \NOUT\Soap\EnumType\ChartTypeEnum::getValidValues())), __LINE__);
        }
        $this->ChartType = $chartType;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\GetChart
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
