<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListIDMessFromRequest StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetListIDMessFromRequest extends AbstractStructBase
{
    /**
     * The StartDate
     * @var string|null
     */
    protected ?string $StartDate = null;
    /**
     * The EndDate
     * @var string|null
     */
    protected ?string $EndDate = null;
    /**
     * The Filter
     * @var \NOUT\Soap\StructType\FilterType|null
     */
    protected ?\NOUT\Soap\StructType\FilterType $Filter = null;
    /**
     * The UserMessagerie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $UserMessagerie = null;
    /**
     * The Sort1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort1 = null;
    /**
     * The Sort2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort2 = null;
    /**
     * The Sort3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort3 = null;
    /**
     * Constructor method for GetListIDMessFromRequest
     * @uses GetListIDMessFromRequest::setStartDate()
     * @uses GetListIDMessFromRequest::setEndDate()
     * @uses GetListIDMessFromRequest::setFilter()
     * @uses GetListIDMessFromRequest::setUserMessagerie()
     * @uses GetListIDMessFromRequest::setSort1()
     * @uses GetListIDMessFromRequest::setSort2()
     * @uses GetListIDMessFromRequest::setSort3()
     * @param string $startDate
     * @param string $endDate
     * @param \NOUT\Soap\StructType\FilterType $filter
     * @param string $userMessagerie
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @param \NOUT\Soap\StructType\SortType $sort3
     */
    public function __construct(?string $startDate = null, ?string $endDate = null, ?\NOUT\Soap\StructType\FilterType $filter = null, ?string $userMessagerie = null, ?\NOUT\Soap\StructType\SortType $sort1 = null, ?\NOUT\Soap\StructType\SortType $sort2 = null, ?\NOUT\Soap\StructType\SortType $sort3 = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setFilter($filter)
            ->setUserMessagerie($userMessagerie)
            ->setSort1($sort1)
            ->setSort2($sort2)
            ->setSort3($sort3);
    }
    /**
     * Get StartDate value
     * @return string|null
     */
    public function getStartDate(): ?string
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setStartDate(?string $startDate = null): self
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        
        return $this;
    }
    /**
     * Get EndDate value
     * @return string|null
     */
    public function getEndDate(): ?string
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setEndDate(?string $endDate = null): self
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        
        return $this;
    }
    /**
     * Get Filter value
     * @return \NOUT\Soap\StructType\FilterType|null
     */
    public function getFilter(): ?\NOUT\Soap\StructType\FilterType
    {
        return $this->Filter;
    }
    /**
     * Set Filter value
     * @param \NOUT\Soap\StructType\FilterType $filter
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setFilter(?\NOUT\Soap\StructType\FilterType $filter = null): self
    {
        $this->Filter = $filter;
        
        return $this;
    }
    /**
     * Get UserMessagerie value
     * @return string|null
     */
    public function getUserMessagerie(): ?string
    {
        return $this->UserMessagerie;
    }
    /**
     * Set UserMessagerie value
     * @param string $userMessagerie
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setUserMessagerie(?string $userMessagerie = null): self
    {
        // validation for constraint: string
        if (!is_null($userMessagerie) && !is_string($userMessagerie)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userMessagerie, true), gettype($userMessagerie)), __LINE__);
        }
        $this->UserMessagerie = $userMessagerie;
        
        return $this;
    }
    /**
     * Get Sort1 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort1(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort1;
    }
    /**
     * Set Sort1 value
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setSort1(?\NOUT\Soap\StructType\SortType $sort1 = null): self
    {
        $this->Sort1 = $sort1;
        
        return $this;
    }
    /**
     * Get Sort2 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort2(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort2;
    }
    /**
     * Set Sort2 value
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setSort2(?\NOUT\Soap\StructType\SortType $sort2 = null): self
    {
        $this->Sort2 = $sort2;
        
        return $this;
    }
    /**
     * Get Sort3 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort3(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort3;
    }
    /**
     * Set Sort3 value
     * @param \NOUT\Soap\StructType\SortType $sort3
     * @return \NOUT\Soap\StructType\GetListIDMessFromRequest
     */
    public function setSort3(?\NOUT\Soap\StructType\SortType $sort3 = null): self
    {
        $this->Sort3 = $sort3;
        
        return $this;
    }
}
