<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetRedoList StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetRedoList extends AbstractStructBase
{
    /**
     * The StartDate
     * @var string|null
     */
    protected ?string $StartDate = null;
    /**
     * The EndDate
     * @var string|null
     */
    protected ?string $EndDate = null;
    /**
     * The DoneBy
     * @var string|null
     */
    protected ?string $DoneBy = null;
    /**
     * The ActionType
     * @var string|null
     */
    protected ?string $ActionType = null;
    /**
     * The Form
     * @var string|null
     */
    protected ?string $Form = null;
    /**
     * The OtherCriteria
     * @var string|null
     */
    protected ?string $OtherCriteria = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * Constructor method for GetRedoList
     * @uses GetRedoList::setStartDate()
     * @uses GetRedoList::setEndDate()
     * @uses GetRedoList::setDoneBy()
     * @uses GetRedoList::setActionType()
     * @uses GetRedoList::setForm()
     * @uses GetRedoList::setOtherCriteria()
     * @uses GetRedoList::setSpecialParamList()
     * @param string $startDate
     * @param string $endDate
     * @param string $doneBy
     * @param string $actionType
     * @param string $form
     * @param string $otherCriteria
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     */
    public function __construct(?string $startDate = null, ?string $endDate = null, ?string $doneBy = null, ?string $actionType = null, ?string $form = null, ?string $otherCriteria = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setDoneBy($doneBy)
            ->setActionType($actionType)
            ->setForm($form)
            ->setOtherCriteria($otherCriteria)
            ->setSpecialParamList($specialParamList);
    }
    /**
     * Get StartDate value
     * @return string|null
     */
    public function getStartDate(): ?string
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setStartDate(?string $startDate = null): self
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        
        return $this;
    }
    /**
     * Get EndDate value
     * @return string|null
     */
    public function getEndDate(): ?string
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setEndDate(?string $endDate = null): self
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        
        return $this;
    }
    /**
     * Get DoneBy value
     * @return string|null
     */
    public function getDoneBy(): ?string
    {
        return $this->DoneBy;
    }
    /**
     * Set DoneBy value
     * @param string $doneBy
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setDoneBy(?string $doneBy = null): self
    {
        // validation for constraint: string
        if (!is_null($doneBy) && !is_string($doneBy)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($doneBy, true), gettype($doneBy)), __LINE__);
        }
        $this->DoneBy = $doneBy;
        
        return $this;
    }
    /**
     * Get ActionType value
     * @return string|null
     */
    public function getActionType(): ?string
    {
        return $this->ActionType;
    }
    /**
     * Set ActionType value
     * @param string $actionType
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setActionType(?string $actionType = null): self
    {
        // validation for constraint: string
        if (!is_null($actionType) && !is_string($actionType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actionType, true), gettype($actionType)), __LINE__);
        }
        $this->ActionType = $actionType;
        
        return $this;
    }
    /**
     * Get Form value
     * @return string|null
     */
    public function getForm(): ?string
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param string $form
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setForm(?string $form = null): self
    {
        // validation for constraint: string
        if (!is_null($form) && !is_string($form)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($form, true), gettype($form)), __LINE__);
        }
        $this->Form = $form;
        
        return $this;
    }
    /**
     * Get OtherCriteria value
     * @return string|null
     */
    public function getOtherCriteria(): ?string
    {
        return $this->OtherCriteria;
    }
    /**
     * Set OtherCriteria value
     * @param string $otherCriteria
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setOtherCriteria(?string $otherCriteria = null): self
    {
        // validation for constraint: string
        if (!is_null($otherCriteria) && !is_string($otherCriteria)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($otherCriteria, true), gettype($otherCriteria)), __LINE__);
        }
        $this->OtherCriteria = $otherCriteria;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\GetRedoList
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
}
