<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSubListContent StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetSubListContent extends AbstractStructBase
{
    /**
     * The Column
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The Record
     * @var string|null
     */
    protected ?string $Record = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * The DisplayMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $DisplayMode = null;
    /**
     * Constructor method for GetSubListContent
     * @uses GetSubListContent::setColumn()
     * @uses GetSubListContent::setRecord()
     * @uses GetSubListContent::setSpecialParamList()
     * @uses GetSubListContent::setDisplayMode()
     * @param string $column
     * @param string $record
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @param string $displayMode
     */
    public function __construct(?string $column = null, ?string $record = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null, ?string $displayMode = null)
    {
        $this
            ->setColumn($column)
            ->setRecord($record)
            ->setSpecialParamList($specialParamList)
            ->setDisplayMode($displayMode);
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\GetSubListContent
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get Record value
     * @return string|null
     */
    public function getRecord(): ?string
    {
        return $this->Record;
    }
    /**
     * Set Record value
     * @param string $record
     * @return \NOUT\Soap\StructType\GetSubListContent
     */
    public function setRecord(?string $record = null): self
    {
        // validation for constraint: string
        if (!is_null($record) && !is_string($record)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($record, true), gettype($record)), __LINE__);
        }
        $this->Record = $record;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\GetSubListContent
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
    /**
     * Get DisplayMode value
     * @return string|null
     */
    public function getDisplayMode(): ?string
    {
        return $this->DisplayMode;
    }
    /**
     * Set DisplayMode value
     * @uses \NOUT\Soap\EnumType\DisplayModeEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\DisplayModeEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $displayMode
     * @return \NOUT\Soap\StructType\GetSubListContent
     */
    public function setDisplayMode(?string $displayMode = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\DisplayModeEnum::valueIsValid($displayMode)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\DisplayModeEnum', is_array($displayMode) ? implode(', ', $displayMode) : var_export($displayMode, true), implode(', ', \NOUT\Soap\EnumType\DisplayModeEnum::getValidValues())), __LINE__);
        }
        $this->DisplayMode = $displayMode;
        
        return $this;
    }
}
