<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUndoListID StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetUndoListID extends AbstractStructBase
{
    /**
     * The StartDate
     * @var string|null
     */
    protected ?string $StartDate = null;
    /**
     * The EndDate
     * @var string|null
     */
    protected ?string $EndDate = null;
    /**
     * The DoneBy
     * @var string|null
     */
    protected ?string $DoneBy = null;
    /**
     * The ActionType
     * @var string|null
     */
    protected ?string $ActionType = null;
    /**
     * The Form
     * @var string|null
     */
    protected ?string $Form = null;
    /**
     * The OtherCriteria
     * @var string|null
     */
    protected ?string $OtherCriteria = null;
    /**
     * The Sort1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort1 = null;
    /**
     * The Sort2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort2 = null;
    /**
     * The Sort3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort3 = null;
    /**
     * Constructor method for GetUndoListID
     * @uses GetUndoListID::setStartDate()
     * @uses GetUndoListID::setEndDate()
     * @uses GetUndoListID::setDoneBy()
     * @uses GetUndoListID::setActionType()
     * @uses GetUndoListID::setForm()
     * @uses GetUndoListID::setOtherCriteria()
     * @uses GetUndoListID::setSort1()
     * @uses GetUndoListID::setSort2()
     * @uses GetUndoListID::setSort3()
     * @param string $startDate
     * @param string $endDate
     * @param string $doneBy
     * @param string $actionType
     * @param string $form
     * @param string $otherCriteria
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @param \NOUT\Soap\StructType\SortType $sort3
     */
    public function __construct(?string $startDate = null, ?string $endDate = null, ?string $doneBy = null, ?string $actionType = null, ?string $form = null, ?string $otherCriteria = null, ?\NOUT\Soap\StructType\SortType $sort1 = null, ?\NOUT\Soap\StructType\SortType $sort2 = null, ?\NOUT\Soap\StructType\SortType $sort3 = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setDoneBy($doneBy)
            ->setActionType($actionType)
            ->setForm($form)
            ->setOtherCriteria($otherCriteria)
            ->setSort1($sort1)
            ->setSort2($sort2)
            ->setSort3($sort3);
    }
    /**
     * Get StartDate value
     * @return string|null
     */
    public function getStartDate(): ?string
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setStartDate(?string $startDate = null): self
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        
        return $this;
    }
    /**
     * Get EndDate value
     * @return string|null
     */
    public function getEndDate(): ?string
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setEndDate(?string $endDate = null): self
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        
        return $this;
    }
    /**
     * Get DoneBy value
     * @return string|null
     */
    public function getDoneBy(): ?string
    {
        return $this->DoneBy;
    }
    /**
     * Set DoneBy value
     * @param string $doneBy
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setDoneBy(?string $doneBy = null): self
    {
        // validation for constraint: string
        if (!is_null($doneBy) && !is_string($doneBy)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($doneBy, true), gettype($doneBy)), __LINE__);
        }
        $this->DoneBy = $doneBy;
        
        return $this;
    }
    /**
     * Get ActionType value
     * @return string|null
     */
    public function getActionType(): ?string
    {
        return $this->ActionType;
    }
    /**
     * Set ActionType value
     * @param string $actionType
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setActionType(?string $actionType = null): self
    {
        // validation for constraint: string
        if (!is_null($actionType) && !is_string($actionType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actionType, true), gettype($actionType)), __LINE__);
        }
        $this->ActionType = $actionType;
        
        return $this;
    }
    /**
     * Get Form value
     * @return string|null
     */
    public function getForm(): ?string
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param string $form
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setForm(?string $form = null): self
    {
        // validation for constraint: string
        if (!is_null($form) && !is_string($form)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($form, true), gettype($form)), __LINE__);
        }
        $this->Form = $form;
        
        return $this;
    }
    /**
     * Get OtherCriteria value
     * @return string|null
     */
    public function getOtherCriteria(): ?string
    {
        return $this->OtherCriteria;
    }
    /**
     * Set OtherCriteria value
     * @param string $otherCriteria
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setOtherCriteria(?string $otherCriteria = null): self
    {
        // validation for constraint: string
        if (!is_null($otherCriteria) && !is_string($otherCriteria)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($otherCriteria, true), gettype($otherCriteria)), __LINE__);
        }
        $this->OtherCriteria = $otherCriteria;
        
        return $this;
    }
    /**
     * Get Sort1 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort1(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort1;
    }
    /**
     * Set Sort1 value
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setSort1(?\NOUT\Soap\StructType\SortType $sort1 = null): self
    {
        $this->Sort1 = $sort1;
        
        return $this;
    }
    /**
     * Get Sort2 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort2(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort2;
    }
    /**
     * Set Sort2 value
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setSort2(?\NOUT\Soap\StructType\SortType $sort2 = null): self
    {
        $this->Sort2 = $sort2;
        
        return $this;
    }
    /**
     * Get Sort3 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort3(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort3;
    }
    /**
     * Set Sort3 value
     * @param \NOUT\Soap\StructType\SortType $sort3
     * @return \NOUT\Soap\StructType\GetUndoListID
     */
    public function setSort3(?\NOUT\Soap\StructType\SortType $sort3 = null): self
    {
        $this->Sort3 = $sort3;
        
        return $this;
    }
}
