<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Import StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Import extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The Import
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Import = null;
    /**
     * The File
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\DataType|null
     */
    protected ?\NOUT\Soap\StructType\DataType $File = null;
    /**
     * Constructor method for Import
     * @uses Import::setTable()
     * @uses Import::setID()
     * @uses Import::setImport()
     * @uses Import::setFile()
     * @param string $table
     * @param string $iD
     * @param string $import
     * @param \NOUT\Soap\StructType\DataType $file
     */
    public function __construct(?string $table = null, ?string $iD = null, ?string $import = null, ?\NOUT\Soap\StructType\DataType $file = null)
    {
        $this
            ->setTable($table)
            ->setID($iD)
            ->setImport($import)
            ->setFile($file);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\Import
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\Import
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get Import value
     * @return string|null
     */
    public function getImport(): ?string
    {
        return $this->Import;
    }
    /**
     * Set Import value
     * @param string $import
     * @return \NOUT\Soap\StructType\Import
     */
    public function setImport(?string $import = null): self
    {
        // validation for constraint: string
        if (!is_null($import) && !is_string($import)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($import, true), gettype($import)), __LINE__);
        }
        $this->Import = $import;
        
        return $this;
    }
    /**
     * Get File value
     * @return \NOUT\Soap\StructType\DataType|null
     */
    public function getFile(): ?\NOUT\Soap\StructType\DataType
    {
        return $this->File;
    }
    /**
     * Set File value
     * @param \NOUT\Soap\StructType\DataType $file
     * @return \NOUT\Soap\StructType\Import
     */
    public function setFile(?\NOUT\Soap\StructType\DataType $file = null): self
    {
        $this->File = $file;
        
        return $this;
    }
}
