<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for InitRecordFromAddress StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class InitRecordFromAddress extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The Record
     * @var string|null
     */
    protected ?string $Record = null;
    /**
     * The Address
     * @var string|null
     */
    protected ?string $Address = null;
    /**
     * Constructor method for InitRecordFromAddress
     * @uses InitRecordFromAddress::setTable()
     * @uses InitRecordFromAddress::setRecord()
     * @uses InitRecordFromAddress::setAddress()
     * @param string $table
     * @param string $record
     * @param string $address
     */
    public function __construct(?string $table = null, ?string $record = null, ?string $address = null)
    {
        $this
            ->setTable($table)
            ->setRecord($record)
            ->setAddress($address);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\InitRecordFromAddress
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get Record value
     * @return string|null
     */
    public function getRecord(): ?string
    {
        return $this->Record;
    }
    /**
     * Set Record value
     * @param string $record
     * @return \NOUT\Soap\StructType\InitRecordFromAddress
     */
    public function setRecord(?string $record = null): self
    {
        // validation for constraint: string
        if (!is_null($record) && !is_string($record)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($record, true), gettype($record)), __LINE__);
        }
        $this->Record = $record;
        
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress(): ?string
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \NOUT\Soap\StructType\InitRecordFromAddress
     */
    public function setAddress(?string $address = null): self
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address, true), gettype($address)), __LINE__);
        }
        $this->Address = $address;
        
        return $this;
    }
}
