<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Paste StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Paste extends AbstractStructBase
{
    /**
     * The Content
     * @var \NOUT\Soap\StructType\DataType|null
     */
    protected ?\NOUT\Soap\StructType\DataType $Content = null;
    /**
     * The Instance
     * @var string|null
     */
    protected ?string $Instance = null;
    /**
     * Constructor method for Paste
     * @uses Paste::setContent()
     * @uses Paste::setInstance()
     * @param \NOUT\Soap\StructType\DataType $content
     * @param string $instance
     */
    public function __construct(?\NOUT\Soap\StructType\DataType $content = null, ?string $instance = null)
    {
        $this
            ->setContent($content)
            ->setInstance($instance);
    }
    /**
     * Get Content value
     * @return \NOUT\Soap\StructType\DataType|null
     */
    public function getContent(): ?\NOUT\Soap\StructType\DataType
    {
        return $this->Content;
    }
    /**
     * Set Content value
     * @param \NOUT\Soap\StructType\DataType $content
     * @return \NOUT\Soap\StructType\Paste
     */
    public function setContent(?\NOUT\Soap\StructType\DataType $content = null): self
    {
        $this->Content = $content;
        
        return $this;
    }
    /**
     * Get Instance value
     * @return string|null
     */
    public function getInstance(): ?string
    {
        return $this->Instance;
    }
    /**
     * Set Instance value
     * @param string $instance
     * @return \NOUT\Soap\StructType\Paste
     */
    public function setInstance(?string $instance = null): self
    {
        // validation for constraint: string
        if (!is_null($instance) && !is_string($instance)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($instance, true), gettype($instance)), __LINE__);
        }
        $this->Instance = $instance;
        
        return $this;
    }
}
