<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for PwdInfo StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class PwdInfo extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The ks
     * @var string|null
     */
    protected ?string $ks = null;
    /**
     * The iv
     * @var string|null
     */
    protected ?string $iv = null;
    /**
     * The cipher
     * @var string|null
     */
    protected ?string $cipher = null;
    /**
     * Constructor method for PwdInfo
     * @uses PwdInfo::set_()
     * @uses PwdInfo::setKs()
     * @uses PwdInfo::setIv()
     * @uses PwdInfo::setCipher()
     * @param string $_
     * @param string $ks
     * @param string $iv
     * @param string $cipher
     */
    public function __construct(?string $_ = null, ?string $ks = null, ?string $iv = null, ?string $cipher = null)
    {
        $this
            ->set_($_)
            ->setKs($ks)
            ->setIv($iv)
            ->setCipher($cipher);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\PwdInfo
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get ks value
     * @return string|null
     */
    public function getKs(): ?string
    {
        return $this->ks;
    }
    /**
     * Set ks value
     * @param string $ks
     * @return \NOUT\Soap\StructType\PwdInfo
     */
    public function setKs(?string $ks = null): self
    {
        // validation for constraint: string
        if (!is_null($ks) && !is_string($ks)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ks, true), gettype($ks)), __LINE__);
        }
        $this->ks = $ks;
        
        return $this;
    }
    /**
     * Get iv value
     * @return string|null
     */
    public function getIv(): ?string
    {
        return $this->iv;
    }
    /**
     * Set iv value
     * @param string $iv
     * @return \NOUT\Soap\StructType\PwdInfo
     */
    public function setIv(?string $iv = null): self
    {
        // validation for constraint: string
        if (!is_null($iv) && !is_string($iv)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iv, true), gettype($iv)), __LINE__);
        }
        $this->iv = $iv;
        
        return $this;
    }
    /**
     * Get cipher value
     * @return string|null
     */
    public function getCipher(): ?string
    {
        return $this->cipher;
    }
    /**
     * Set cipher value
     * @param string $cipher
     * @return \NOUT\Soap\StructType\PwdInfo
     */
    public function setCipher(?string $cipher = null): self
    {
        // validation for constraint: string
        if (!is_null($cipher) && !is_string($cipher)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cipher, true), gettype($cipher)), __LINE__);
        }
        $this->cipher = $cipher;
        
        return $this;
    }
}
