<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ReorderSubList StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ReorderSubList extends AbstractStructBase
{
    /**
     * The column
     * @var string|null
     */
    protected ?string $column = null;
    /**
     * The items
     * @var string|null
     */
    protected ?string $items = null;
    /**
     * The moveType
     * @var string|null
     */
    protected ?string $moveType = null;
    /**
     * The scale
     * @var int|null
     */
    protected ?int $scale = null;
    /**
     * Constructor method for ReorderSubList
     * @uses ReorderSubList::setColumn()
     * @uses ReorderSubList::setItems()
     * @uses ReorderSubList::setMoveType()
     * @uses ReorderSubList::setScale()
     * @param string $column
     * @param string $items
     * @param string $moveType
     * @param int $scale
     */
    public function __construct(?string $column = null, ?string $items = null, ?string $moveType = null, ?int $scale = null)
    {
        $this
            ->setColumn($column)
            ->setItems($items)
            ->setMoveType($moveType)
            ->setScale($scale);
    }
    /**
     * Get column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->column;
    }
    /**
     * Set column value
     * @param string $column
     * @return \NOUT\Soap\StructType\ReorderSubList
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->column = $column;
        
        return $this;
    }
    /**
     * Get items value
     * @return string|null
     */
    public function getItems(): ?string
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param string $items
     * @return \NOUT\Soap\StructType\ReorderSubList
     */
    public function setItems(?string $items = null): self
    {
        // validation for constraint: string
        if (!is_null($items) && !is_string($items)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($items, true), gettype($items)), __LINE__);
        }
        $this->items = $items;
        
        return $this;
    }
    /**
     * Get moveType value
     * @return string|null
     */
    public function getMoveType(): ?string
    {
        return $this->moveType;
    }
    /**
     * Set moveType value
     * @param string $moveType
     * @return \NOUT\Soap\StructType\ReorderSubList
     */
    public function setMoveType(?string $moveType = null): self
    {
        // validation for constraint: string
        if (!is_null($moveType) && !is_string($moveType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($moveType, true), gettype($moveType)), __LINE__);
        }
        $this->moveType = $moveType;
        
        return $this;
    }
    /**
     * Get scale value
     * @return int|null
     */
    public function getScale(): ?int
    {
        return $this->scale;
    }
    /**
     * Set scale value
     * @param int $scale
     * @return \NOUT\Soap\StructType\ReorderSubList
     */
    public function setScale(?int $scale = null): self
    {
        // validation for constraint: int
        if (!is_null($scale) && !(is_int($scale) || ctype_digit($scale))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($scale, true), gettype($scale)), __LINE__);
        }
        $this->scale = $scale;
        
        return $this;
    }
}
