<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Search StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Search extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * The Checksum
     * @var int|null
     */
    protected ?int $Checksum = null;
    /**
     * The DisplayMode
     * @var string|null
     */
    protected ?string $DisplayMode = null;
    /**
     * The CallingColumn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $CallingColumn = null;
    /**
     * The CallingInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\CallingInfoType|null
     */
    protected ?\NOUT\Soap\StructType\CallingInfoType $CallingInfo = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for Search
     * @uses Search::setTable()
     * @uses Search::setParamXML()
     * @uses Search::setSpecialParamList()
     * @uses Search::setChecksum()
     * @uses Search::setDisplayMode()
     * @uses Search::setCallingColumn()
     * @uses Search::setCallingInfo()
     * @uses Search::setVirtualParamList()
     * @param string $table
     * @param string $paramXML
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @param int $checksum
     * @param string $displayMode
     * @param string $callingColumn
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $table = null, ?string $paramXML = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null, ?int $checksum = null, ?string $displayMode = null, ?string $callingColumn = null, ?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setTable($table)
            ->setParamXML($paramXML)
            ->setSpecialParamList($specialParamList)
            ->setChecksum($checksum)
            ->setDisplayMode($displayMode)
            ->setCallingColumn($callingColumn)
            ->setCallingInfo($callingInfo)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\Search
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\Search
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\Search
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
    /**
     * Get Checksum value
     * @return int|null
     */
    public function getChecksum(): ?int
    {
        return $this->Checksum;
    }
    /**
     * Set Checksum value
     * @param int $checksum
     * @return \NOUT\Soap\StructType\Search
     */
    public function setChecksum(?int $checksum = null): self
    {
        // validation for constraint: int
        if (!is_null($checksum) && !(is_int($checksum) || ctype_digit($checksum))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($checksum, true), gettype($checksum)), __LINE__);
        }
        $this->Checksum = $checksum;
        
        return $this;
    }
    /**
     * Get DisplayMode value
     * @return string|null
     */
    public function getDisplayMode(): ?string
    {
        return $this->DisplayMode;
    }
    /**
     * Set DisplayMode value
     * @uses \NOUT\Soap\EnumType\DisplayModeEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\DisplayModeEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $displayMode
     * @return \NOUT\Soap\StructType\Search
     */
    public function setDisplayMode(?string $displayMode = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\DisplayModeEnum::valueIsValid($displayMode)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\DisplayModeEnum', is_array($displayMode) ? implode(', ', $displayMode) : var_export($displayMode, true), implode(', ', \NOUT\Soap\EnumType\DisplayModeEnum::getValidValues())), __LINE__);
        }
        $this->DisplayMode = $displayMode;
        
        return $this;
    }
    /**
     * Get CallingColumn value
     * @return string|null
     */
    public function getCallingColumn(): ?string
    {
        return $this->CallingColumn;
    }
    /**
     * Set CallingColumn value
     * @param string $callingColumn
     * @return \NOUT\Soap\StructType\Search
     */
    public function setCallingColumn(?string $callingColumn = null): self
    {
        // validation for constraint: string
        if (!is_null($callingColumn) && !is_string($callingColumn)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callingColumn, true), gettype($callingColumn)), __LINE__);
        }
        $this->CallingColumn = $callingColumn;
        
        return $this;
    }
    /**
     * Get CallingInfo value
     * @return \NOUT\Soap\StructType\CallingInfoType|null
     */
    public function getCallingInfo(): ?\NOUT\Soap\StructType\CallingInfoType
    {
        return $this->CallingInfo;
    }
    /**
     * Set CallingInfo value
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @return \NOUT\Soap\StructType\Search
     */
    public function setCallingInfo(?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null): self
    {
        $this->CallingInfo = $callingInfo;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\Search
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
