<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectForm StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SelectForm extends AbstractStructBase
{
    /**
     * The Form
     * @var string|null
     */
    protected ?string $Form = null;
    /**
     * Constructor method for SelectForm
     * @uses SelectForm::setForm()
     * @param string $form
     */
    public function __construct(?string $form = null)
    {
        $this
            ->setForm($form);
    }
    /**
     * Get Form value
     * @return string|null
     */
    public function getForm(): ?string
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param string $form
     * @return \NOUT\Soap\StructType\SelectForm
     */
    public function setForm(?string $form = null): self
    {
        // validation for constraint: string
        if (!is_null($form) && !is_string($form)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($form, true), gettype($form)), __LINE__);
        }
        $this->Form = $form;
        
        return $this;
    }
}
