<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectItems StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SelectItems extends AbstractStructBase
{
    /**
     * The items
     * @var string|null
     */
    protected ?string $items = null;
    /**
     * The CallingColumn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $CallingColumn = null;
    /**
     * The CallingInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\CallingInfoType|null
     */
    protected ?\NOUT\Soap\StructType\CallingInfoType $CallingInfo = null;
    /**
     * Constructor method for SelectItems
     * @uses SelectItems::setItems()
     * @uses SelectItems::setCallingColumn()
     * @uses SelectItems::setCallingInfo()
     * @param string $items
     * @param string $callingColumn
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     */
    public function __construct(?string $items = null, ?string $callingColumn = null, ?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null)
    {
        $this
            ->setItems($items)
            ->setCallingColumn($callingColumn)
            ->setCallingInfo($callingInfo);
    }
    /**
     * Get items value
     * @return string|null
     */
    public function getItems(): ?string
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param string $items
     * @return \NOUT\Soap\StructType\SelectItems
     */
    public function setItems(?string $items = null): self
    {
        // validation for constraint: string
        if (!is_null($items) && !is_string($items)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($items, true), gettype($items)), __LINE__);
        }
        $this->items = $items;
        
        return $this;
    }
    /**
     * Get CallingColumn value
     * @return string|null
     */
    public function getCallingColumn(): ?string
    {
        return $this->CallingColumn;
    }
    /**
     * Set CallingColumn value
     * @param string $callingColumn
     * @return \NOUT\Soap\StructType\SelectItems
     */
    public function setCallingColumn(?string $callingColumn = null): self
    {
        // validation for constraint: string
        if (!is_null($callingColumn) && !is_string($callingColumn)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callingColumn, true), gettype($callingColumn)), __LINE__);
        }
        $this->CallingColumn = $callingColumn;
        
        return $this;
    }
    /**
     * Get CallingInfo value
     * @return \NOUT\Soap\StructType\CallingInfoType|null
     */
    public function getCallingInfo(): ?\NOUT\Soap\StructType\CallingInfoType
    {
        return $this->CallingInfo;
    }
    /**
     * Set CallingInfo value
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @return \NOUT\Soap\StructType\SelectItems
     */
    public function setCallingInfo(?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null): self
    {
        $this->CallingInfo = $callingInfo;
        
        return $this;
    }
}
