<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectPrintTemplate StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SelectPrintTemplate extends AbstractStructBase
{
    /**
     * The Template
     * @var string|null
     */
    protected ?string $Template = null;
    /**
     * Constructor method for SelectPrintTemplate
     * @uses SelectPrintTemplate::setTemplate()
     * @param string $template
     */
    public function __construct(?string $template = null)
    {
        $this
            ->setTemplate($template);
    }
    /**
     * Get Template value
     * @return string|null
     */
    public function getTemplate(): ?string
    {
        return $this->Template;
    }
    /**
     * Set Template value
     * @param string $template
     * @return \NOUT\Soap\StructType\SelectPrintTemplate
     */
    public function setTemplate(?string $template = null): self
    {
        // validation for constraint: string
        if (!is_null($template) && !is_string($template)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($template, true), gettype($template)), __LINE__);
        }
        $this->Template = $template;
        
        return $this;
    }
}
