<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SetOrderList StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SetOrderList extends AbstractStructBase
{
    /**
     * The items
     * @var string|null
     */
    protected ?string $items = null;
    /**
     * The offset
     * @var int|null
     */
    protected ?int $offset = null;
    /**
     * Constructor method for SetOrderList
     * @uses SetOrderList::setItems()
     * @uses SetOrderList::setOffset()
     * @param string $items
     * @param int $offset
     */
    public function __construct(?string $items = null, ?int $offset = null)
    {
        $this
            ->setItems($items)
            ->setOffset($offset);
    }
    /**
     * Get items value
     * @return string|null
     */
    public function getItems(): ?string
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param string $items
     * @return \NOUT\Soap\StructType\SetOrderList
     */
    public function setItems(?string $items = null): self
    {
        // validation for constraint: string
        if (!is_null($items) && !is_string($items)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($items, true), gettype($items)), __LINE__);
        }
        $this->items = $items;
        
        return $this;
    }
    /**
     * Get offset value
     * @return int|null
     */
    public function getOffset(): ?int
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \NOUT\Soap\StructType\SetOrderList
     */
    public function setOffset(?int $offset = null): self
    {
        // validation for constraint: int
        if (!is_null($offset) && !(is_int($offset) || ctype_digit($offset))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($offset, true), gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        
        return $this;
    }
}
