<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SetOrderListResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SetOrderListResponse extends AbstractStructBase
{
    /**
     * The Value
     * @var string|null
     */
    protected ?string $Value = null;
    /**
     * Constructor method for SetOrderListResponse
     * @uses SetOrderListResponse::setValue()
     * @param string $value
     */
    public function __construct(?string $value = null)
    {
        $this
            ->setValue($value);
    }
    /**
     * Get Value value
     * @return string|null
     */
    public function getValue(): ?string
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param string $value
     * @return \NOUT\Soap\StructType\SetOrderListResponse
     */
    public function setValue(?string $value = null): self
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        
        return $this;
    }
}
