<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Update StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Update extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The Complete
     * @var int|null
     */
    protected ?int $Complete = null;
    /**
     * The UpdateData
     * @var string|null
     */
    protected ?string $UpdateData = null;
    /**
     * The AssistantMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $AssistantMode = null;
    /**
     * The Refresh
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $Refresh = null;
    /**
     * The ColumnsToRefresh
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ColumnsToRefresh = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for Update
     * @uses Update::setTable()
     * @uses Update::setParamXML()
     * @uses Update::setComplete()
     * @uses Update::setUpdateData()
     * @uses Update::setAssistantMode()
     * @uses Update::setRefresh()
     * @uses Update::setColumnsToRefresh()
     * @uses Update::setVirtualParamList()
     * @param string $table
     * @param string $paramXML
     * @param int $complete
     * @param string $updateData
     * @param string $assistantMode
     * @param int $refresh
     * @param string $columnsToRefresh
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $table = null, ?string $paramXML = null, ?int $complete = null, ?string $updateData = null, ?string $assistantMode = null, ?int $refresh = null, ?string $columnsToRefresh = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setTable($table)
            ->setParamXML($paramXML)
            ->setComplete($complete)
            ->setUpdateData($updateData)
            ->setAssistantMode($assistantMode)
            ->setRefresh($refresh)
            ->setColumnsToRefresh($columnsToRefresh)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\Update
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\Update
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get Complete value
     * @return int|null
     */
    public function getComplete(): ?int
    {
        return $this->Complete;
    }
    /**
     * Set Complete value
     * @param int $complete
     * @return \NOUT\Soap\StructType\Update
     */
    public function setComplete(?int $complete = null): self
    {
        // validation for constraint: int
        if (!is_null($complete) && !(is_int($complete) || ctype_digit($complete))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($complete, true), gettype($complete)), __LINE__);
        }
        $this->Complete = $complete;
        
        return $this;
    }
    /**
     * Get UpdateData value
     * @return string|null
     */
    public function getUpdateData(): ?string
    {
        return $this->UpdateData;
    }
    /**
     * Set UpdateData value
     * @param string $updateData
     * @return \NOUT\Soap\StructType\Update
     */
    public function setUpdateData(?string $updateData = null): self
    {
        // validation for constraint: string
        if (!is_null($updateData) && !is_string($updateData)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateData, true), gettype($updateData)), __LINE__);
        }
        $this->UpdateData = $updateData;
        
        return $this;
    }
    /**
     * Get AssistantMode value
     * @return string|null
     */
    public function getAssistantMode(): ?string
    {
        return $this->AssistantMode;
    }
    /**
     * Set AssistantMode value
     * @param string $assistantMode
     * @return \NOUT\Soap\StructType\Update
     */
    public function setAssistantMode(?string $assistantMode = null): self
    {
        // validation for constraint: string
        if (!is_null($assistantMode) && !is_string($assistantMode)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($assistantMode, true), gettype($assistantMode)), __LINE__);
        }
        $this->AssistantMode = $assistantMode;
        
        return $this;
    }
    /**
     * Get Refresh value
     * @return int|null
     */
    public function getRefresh(): ?int
    {
        return $this->Refresh;
    }
    /**
     * Set Refresh value
     * @param int $refresh
     * @return \NOUT\Soap\StructType\Update
     */
    public function setRefresh(?int $refresh = null): self
    {
        // validation for constraint: int
        if (!is_null($refresh) && !(is_int($refresh) || ctype_digit($refresh))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($refresh, true), gettype($refresh)), __LINE__);
        }
        $this->Refresh = $refresh;
        
        return $this;
    }
    /**
     * Get ColumnsToRefresh value
     * @return string|null
     */
    public function getColumnsToRefresh(): ?string
    {
        return $this->ColumnsToRefresh;
    }
    /**
     * Set ColumnsToRefresh value
     * @param string $columnsToRefresh
     * @return \NOUT\Soap\StructType\Update
     */
    public function setColumnsToRefresh(?string $columnsToRefresh = null): self
    {
        // validation for constraint: string
        if (!is_null($columnsToRefresh) && !is_string($columnsToRefresh)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($columnsToRefresh, true), gettype($columnsToRefresh)), __LINE__);
        }
        $this->ColumnsToRefresh = $columnsToRefresh;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\Update
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
