<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateColumnMessageValueInBatch StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class UpdateColumnMessageValueInBatch extends AbstractStructBase
{
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The Column
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The Value
     * @var string|null
     */
    protected ?string $Value = null;
    /**
     * Constructor method for UpdateColumnMessageValueInBatch
     * @uses UpdateColumnMessageValueInBatch::setIDMessage()
     * @uses UpdateColumnMessageValueInBatch::setColumn()
     * @uses UpdateColumnMessageValueInBatch::setValue()
     * @param string $iDMessage
     * @param string $column
     * @param string $value
     */
    public function __construct(?string $iDMessage = null, ?string $column = null, ?string $value = null)
    {
        $this
            ->setIDMessage($iDMessage)
            ->setColumn($column)
            ->setValue($value);
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\UpdateColumnMessageValueInBatch
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\UpdateColumnMessageValueInBatch
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get Value value
     * @return string|null
     */
    public function getValue(): ?string
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param string $value
     * @return \NOUT\Soap\StructType\UpdateColumnMessageValueInBatch
     */
    public function setValue(?string $value = null): self
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        
        return $this;
    }
}
