<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateFilter StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class UpdateFilter extends AbstractStructBase
{
    /**
     * The ID
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The UpdateData
     * @var string|null
     */
    protected ?string $UpdateData = null;
    /**
     * Constructor method for UpdateFilter
     * @uses UpdateFilter::setID()
     * @uses UpdateFilter::setUpdateData()
     * @param string $iD
     * @param string $updateData
     */
    public function __construct(?string $iD = null, ?string $updateData = null)
    {
        $this
            ->setID($iD)
            ->setUpdateData($updateData);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\UpdateFilter
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get UpdateData value
     * @return string|null
     */
    public function getUpdateData(): ?string
    {
        return $this->UpdateData;
    }
    /**
     * Set UpdateData value
     * @param string $updateData
     * @return \NOUT\Soap\StructType\UpdateFilter
     */
    public function setUpdateData(?string $updateData = null): self
    {
        // validation for constraint: string
        if (!is_null($updateData) && !is_string($updateData)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateData, true), gettype($updateData)), __LINE__);
        }
        $this->UpdateData = $updateData;
        
        return $this;
    }
}
