<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateFolder StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class UpdateFolder extends AbstractStructBase
{
    /**
     * The IDFolder
     * @var string|null
     */
    protected ?string $IDFolder = null;
    /**
     * The UpdateData
     * @var string|null
     */
    protected ?string $UpdateData = null;
    /**
     * Constructor method for UpdateFolder
     * @uses UpdateFolder::setIDFolder()
     * @uses UpdateFolder::setUpdateData()
     * @param string $iDFolder
     * @param string $updateData
     */
    public function __construct(?string $iDFolder = null, ?string $updateData = null)
    {
        $this
            ->setIDFolder($iDFolder)
            ->setUpdateData($updateData);
    }
    /**
     * Get IDFolder value
     * @return string|null
     */
    public function getIDFolder(): ?string
    {
        return $this->IDFolder;
    }
    /**
     * Set IDFolder value
     * @param string $iDFolder
     * @return \NOUT\Soap\StructType\UpdateFolder
     */
    public function setIDFolder(?string $iDFolder = null): self
    {
        // validation for constraint: string
        if (!is_null($iDFolder) && !is_string($iDFolder)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDFolder, true), gettype($iDFolder)), __LINE__);
        }
        $this->IDFolder = $iDFolder;
        
        return $this;
    }
    /**
     * Get UpdateData value
     * @return string|null
     */
    public function getUpdateData(): ?string
    {
        return $this->UpdateData;
    }
    /**
     * Set UpdateData value
     * @param string $updateData
     * @return \NOUT\Soap\StructType\UpdateFolder
     */
    public function setUpdateData(?string $updateData = null): self
    {
        // validation for constraint: string
        if (!is_null($updateData) && !is_string($updateData)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateData, true), gettype($updateData)), __LINE__);
        }
        $this->UpdateData = $updateData;
        
        return $this;
    }
}
