<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for VirtualParamListType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class VirtualParamListType extends AbstractStructBase
{
    /**
     * The VirtualParam
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \NOUT\Soap\StructType\VirtualParamType[]
     */
    protected ?array $VirtualParam = null;
    /**
     * Constructor method for VirtualParamListType
     * @uses VirtualParamListType::setVirtualParam()
     * @param \NOUT\Soap\StructType\VirtualParamType[] $virtualParam
     */
    public function __construct(?array $virtualParam = null)
    {
        $this
            ->setVirtualParam($virtualParam);
    }
    /**
     * Get VirtualParam value
     * @return \NOUT\Soap\StructType\VirtualParamType[]
     */
    public function getVirtualParam(): ?array
    {
        return $this->VirtualParam;
    }
    /**
     * This method is responsible for validating the value(s) passed to the setVirtualParam method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVirtualParam method
     * This has to validate that each item contained by the array match the itemType constraint
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVirtualParamForArrayConstraintFromSetVirtualParam(?array $values = []): string
    {
        if (!is_array($values)) {
            return '';
        }
        $message = '';
        $invalidValues = [];
        foreach ($values as $virtualParamListTypeVirtualParamItem) {
            // validation for constraint: itemType
            if (!$virtualParamListTypeVirtualParamItem instanceof \NOUT\Soap\StructType\VirtualParamType) {
                $invalidValues[] = is_object($virtualParamListTypeVirtualParamItem) ? get_class($virtualParamListTypeVirtualParamItem) : sprintf('%s(%s)', gettype($virtualParamListTypeVirtualParamItem), var_export($virtualParamListTypeVirtualParamItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VirtualParam property can only contain items of type \NOUT\Soap\StructType\VirtualParamType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        
        return $message;
    }
    /**
     * Set VirtualParam value
     * @throws InvalidArgumentException
     * @param \NOUT\Soap\StructType\VirtualParamType[] $virtualParam
     * @return \NOUT\Soap\StructType\VirtualParamListType
     */
    public function setVirtualParam(?array $virtualParam = null): self
    {
        // validation for constraint: array
        if ('' !== ($virtualParamArrayErrorMessage = self::validateVirtualParamForArrayConstraintFromSetVirtualParam($virtualParam))) {
            throw new InvalidArgumentException($virtualParamArrayErrorMessage, __LINE__);
        }
        $this->VirtualParam = $virtualParam;
        
        return $this;
    }
    /**
     * Add item to VirtualParam value
     * @throws InvalidArgumentException
     * @param \NOUT\Soap\StructType\VirtualParamType $item
     * @return \NOUT\Soap\StructType\VirtualParamListType
     */
    public function addToVirtualParam(\NOUT\Soap\StructType\VirtualParamType $item): self
    {
        // validation for constraint: itemType
        if (!$item instanceof \NOUT\Soap\StructType\VirtualParamType) {
            throw new InvalidArgumentException(sprintf('The VirtualParam property can only contain items of type \NOUT\Soap\StructType\VirtualParamType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VirtualParam[] = $item;
        
        return $this;
    }
}
